;--------------------------------------------------------
; File Created by SDCC : free open source ANSI-C Compiler
; Version 3.6.8 #9946 (CYGWIN)
;--------------------------------------------------------
	.module map_utils
	.optsdcc -mz80
	
;--------------------------------------------------------
; Public variables in this module
;--------------------------------------------------------
	.globl _typeOfTile
	.globl _tileValue
	.globl _tileCell
	.globl _reactivarSwitch
	.globl _activarSwitch
	.globl _redibujarSwitches
	.globl _redibujarTile
	.globl _descomprimir_pintarMapa
	.globl _pintarMapaRandom
	.globl _escribirNombreMapa
	.globl _pintarMapa
	.globl _punteroMapa
	.globl _printTxt
	.globl _playSFX
	.globl _cpct_zx7b_decrunch_s
	.globl _cpct_etm_drawTilemap4x8_ag
	.globl _cpct_etm_setDrawTilemap4x8_ag
	.globl _cpct_getRandom_mxor_u8
	.globl _cpct_getScreenPtr
	.globl _cpct_drawSolidBox
	.globl _map_names
;--------------------------------------------------------
; special function registers
;--------------------------------------------------------
;--------------------------------------------------------
; ram data
;--------------------------------------------------------
	.area _DATA
;--------------------------------------------------------
; ram data
;--------------------------------------------------------
	.area _INITIALIZED
;--------------------------------------------------------
; absolute external ram data
;--------------------------------------------------------
	.area _DABS (ABS)
;--------------------------------------------------------
; global & static initialisations
;--------------------------------------------------------
	.area _HOME
	.area _GSINIT
	.area _GSFINAL
	.area _GSINIT
;--------------------------------------------------------
; Home
;--------------------------------------------------------
	.area _HOME
	.area _HOME
;--------------------------------------------------------
; code
;--------------------------------------------------------
	.area _CODE
;src/map_utils.c:37: void punteroMapa(u8 pantallaDemo) {
;	---------------------------------
; Function punteroMapa
; ---------------------------------
_punteroMapa::
;src/map_utils.c:39: u8 mapa_anterior = mapa_actual;
	ld	hl,#_mapa_actual + 0
	ld	c, (hl)
;src/map_utils.c:41: if (selectedStage == NUM_MAPA_RANDOM || pantallaDemo) {
	ld	a,(#_selectedStage + 0)
	sub	a, #0x06
	jr	Z,00101$
	ld	hl, #2+0
	add	hl, sp
	ld	a, (hl)
	or	a, a
	jr	Z,00105$
;src/map_utils.c:42: do {
00101$:
;src/map_utils.c:43: mapa_actual = (cpct_rand() % NUM_MAPAS) + 1;
	push	bc
	call	_cpct_getRandom_mxor_u8
	ld	d, l
	ld	a, #0x05
	push	af
	inc	sp
	push	de
	inc	sp
	call	__moduchar
	pop	af
	ld	a, l
	pop	bc
	ld	hl, #_mapa_actual
	inc	a
	ld	(hl), a
;src/map_utils.c:44: } while (mapa_actual == mapa_anterior);
	ld	a,(#_mapa_actual + 0)
	sub	a, c
	jr	Z,00101$
	jr	00106$
00105$:
;src/map_utils.c:46: mapa_actual = selectedStage;
	ld	a,(#_selectedStage + 0)
	ld	(#_mapa_actual + 0),a
00106$:
;src/map_utils.c:51: mapa_ptr = (u8*) mapa1_end;
	ld	hl, #_mapa1+93
	ld	(_mapa_ptr), hl
;src/map_utils.c:52: if (mapa_actual == 2) mapa_ptr = (u8*) mapa2_end;
	ld	a,(#_mapa_actual + 0)
	sub	a, #0x02
	jr	NZ,00109$
	ld	hl, #_mapa2+110
	ld	(_mapa_ptr), hl
00109$:
;src/map_utils.c:53: if (mapa_actual == 3) mapa_ptr = (u8*) mapa3_end;
	ld	a,(#_mapa_actual + 0)
	sub	a, #0x03
	jr	NZ,00111$
	ld	hl, #_mapa3+84
	ld	(_mapa_ptr), hl
00111$:
;src/map_utils.c:54: if (mapa_actual == 4) mapa_ptr = (u8*) mapa4_end;
	ld	a,(#_mapa_actual + 0)
	sub	a, #0x04
	jr	NZ,00113$
	ld	hl, #_mapa4+80
	ld	(_mapa_ptr), hl
00113$:
;src/map_utils.c:55: if (mapa_actual == 5) mapa_ptr = (u8*) mapa5_end;
	ld	a,(#_mapa_actual + 0)
	sub	a, #0x05
	ret	NZ
	ld	hl, #_mapa5+98
	ld	(_mapa_ptr), hl
	ret
_map_names:
	.ascii "SPELLBOUND"
	.db 0x00
	.ascii "HOCUSPOCVS"
	.db 0x00
	.ascii "   ANKH   "
	.db 0x00
	.ascii "SORTILEGE "
	.db 0x00
	.ascii " ALACAZAM "
	.db 0x00
	.ascii " BE LUCKY "
	.db 0x00
;src/map_utils.c:65: void pintarMapa() {
;	---------------------------------
; Function pintarMapa
; ---------------------------------
_pintarMapa::
;src/map_utils.c:69: u8* vmem_buffer = VMEM_BUFFER1;
	ld	bc, #0xc000
;src/map_utils.c:72: for (j = NUM_BUFFERS; j > 0; j--) {
	ld	e, #0x02
00105$:
;src/map_utils.c:75: cpct_etm_setDrawTilemap4x8_ag(2, MAPA_H, MAPA_W, &tl_tileset_00[0]);
	push	bc
	push	de
	ld	hl, #_tl_tileset_00
	push	hl
	ld	hl, #0x0014
	push	hl
	ld	hl, #0x1202
	push	hl
	call	_cpct_etm_setDrawTilemap4x8_ag
	pop	de
	pop	bc
;src/map_utils.c:77: for (i = 0; i < 20; i = i + 2) {
	ld	d, #0x00
00103$:
;src/map_utils.c:78: vmem_pos = cpct_getScreenPtr(vmem_buffer, AREA_JUEGO_IZQ + (i*4), AREA_JUEGO_SUP);
	ld	a, d
	add	a, a
	add	a, a
	ld	h, a
	push	bc
	pop	iy
	push	bc
	push	de
	ld	a, #0x30
	push	af
	inc	sp
	push	hl
	inc	sp
	push	iy
	call	_cpct_getScreenPtr
	pop	de
	pop	bc
;src/map_utils.c:79: cpct_etm_drawTilemap4x8_ag(vmem_pos, &mapa[i]);
	ld	iy, #_mapa
	push	bc
	ld	c,d
	ld	b,#0x00
	add	iy, bc
	push	de
	push	iy
	push	hl
	call	_cpct_etm_drawTilemap4x8_ag
	pop	de
	pop	bc
;src/map_utils.c:77: for (i = 0; i < 20; i = i + 2) {
	inc	d
	inc	d
	ld	a, d
	sub	a, #0x14
	jr	C,00103$
;src/map_utils.c:81: vmem_buffer = VMEM_BUFFER2;
	ld	bc, #0x8000
;src/map_utils.c:72: for (j = NUM_BUFFERS; j > 0; j--) {
	ld	d, e
	dec	d
	ld	a,d
	ld	e,a
	or	a, a
	jr	NZ,00105$
	ret
;src/map_utils.c:85: void escribirNombreMapa() {
;	---------------------------------
; Function escribirNombreMapa
; ---------------------------------
_escribirNombreMapa::
;src/map_utils.c:86: printTxt(map_names[selectedStage - 1], CENTRADO, 18, NO, 14);
	ld	bc, #_map_names+0
	ld	hl,#_selectedStage + 0
	ld	e, (hl)
	dec	e
	ld	d,#0x00
	ld	l, e
	ld	h, d
	add	hl, hl
	add	hl, hl
	add	hl, de
	add	hl, hl
	add	hl, de
	add	hl, bc
	ld	bc, #0x0e00
	push	bc
	ld	bc, #0x1200
	push	bc
	push	hl
	call	_printTxt
	pop	af
	pop	af
	pop	af
	ret
;src/map_utils.c:93: void pintarMapaRandom() {
;	---------------------------------
; Function pintarMapaRandom
; ---------------------------------
_pintarMapaRandom::
	call	___sdcc_enter_ix
	push	af
	dec	sp
;src/map_utils.c:98: for (i = 1; i < NUM_MAPAS + 1; i++) {
	ld	c, #0x01
00118$:
;src/map_utils.c:99: if (i == 1) mapa_ptr = (u8*) mapa1_end;
	ld	a, c
	dec	a
	jr	NZ,00102$
	ld	iy, #_mapa_ptr
	ld	0 (iy), #<((_mapa1 + 0x005d))
	ld	1 (iy), #>((_mapa1 + 0x005d))
00102$:
;src/map_utils.c:100: if (i == 2) mapa_ptr = (u8*) mapa2_end;
	ld	a, c
	sub	a, #0x02
	jr	NZ,00104$
	ld	iy, #_mapa_ptr
	ld	0 (iy), #<((_mapa2 + 0x006e))
	ld	1 (iy), #>((_mapa2 + 0x006e))
00104$:
;src/map_utils.c:101: if (i == 3) mapa_ptr = (u8*) mapa3_end;
	ld	a, c
	sub	a, #0x03
	jr	NZ,00106$
	ld	iy, #_mapa_ptr
	ld	0 (iy), #<((_mapa3 + 0x0054))
	ld	1 (iy), #>((_mapa3 + 0x0054))
00106$:
;src/map_utils.c:102: if (i == 4) mapa_ptr = (u8*) mapa4_end;
	ld	a, c
	sub	a, #0x04
	jr	NZ,00108$
	ld	iy, #_mapa_ptr
	ld	0 (iy), #<((_mapa4 + 0x0050))
	ld	1 (iy), #>((_mapa4 + 0x0050))
00108$:
;src/map_utils.c:103: if (i == 5) mapa_ptr = (u8*) mapa5_end;
	ld	a, c
	sub	a, #0x05
	jr	NZ,00110$
	ld	iy, #_mapa_ptr
	ld	0 (iy), #<((_mapa5 + 0x0062))
	ld	1 (iy), #>((_mapa5 + 0x0062))
00110$:
;src/map_utils.c:104: cpct_zx7b_decrunch_s((void *) (&mapa[0] + TILES_TOTALES - 1), (void *) mapa_ptr);
	ld	hl, (_mapa_ptr)
	ld	de, #(_mapa + 0x0167)
	push	bc
	push	hl
	push	de
	call	_cpct_zx7b_decrunch_s
	pop	bc
;src/map_utils.c:106: vmem_buffer = VMEM_BUFFER1;
	ld	de, #0xc000
;src/map_utils.c:107: for (j = NUM_BUFFERS; j > 0; j--) {
	ld	b, #0x02
	ld	a, c
	rlca
	rlca
	rlca
	rlca
	and	a, #0xf0
	add	a, #0xff
	ld	-1 (ix), a
	ld	a, c
	sub	a, #0x05
	ld	a, #0x00
	rla
	ld	-2 (ix), a
	ld	l, c
	dec	l
	ld	a, l
	rlca
	rlca
	rlca
	rlca
	and	a, #0xf0
	ld	-3 (ix), a
00116$:
;src/map_utils.c:108: cpct_etm_setDrawTilemap4x8_ag(4, MAPA_H, MAPA_W, &tl_tileset_00[0]);
	push	bc
	push	de
	ld	hl, #_tl_tileset_00
	push	hl
	ld	hl, #0x0014
	push	hl
	ld	hl, #0x1204
	push	hl
	call	_cpct_etm_setDrawTilemap4x8_ag
	pop	de
	push	de
	ld	a, #0x30
	push	af
	inc	sp
	ld	a, -3 (ix)
	push	af
	inc	sp
	push	de
	call	_cpct_getScreenPtr
	pop	de
	pop	bc
	push	hl
	pop	iy
;src/map_utils.c:110: cpct_etm_drawTilemap4x8_ag(vmem_pos, &mapa[(i - 1) * 4]);
	ld	l, c
	ld	h, #0x00
	dec	hl
	add	hl, hl
	add	hl, hl
	push	bc
	ld	bc, #_mapa
	add	hl, bc
	push	de
	push	hl
	push	iy
	call	_cpct_etm_drawTilemap4x8_ag
	pop	de
	pop	bc
;src/map_utils.c:111: if (i > 0 && i < 5) {
	ld	a, c
	or	a, a
	jr	Z,00112$
	ld	a, -2 (ix)
	or	a, a
	jr	Z,00112$
;src/map_utils.c:112: vmem_pos = cpct_getScreenPtr(vmem_buffer, AREA_JUEGO_IZQ + (i * 16) - 1, AREA_JUEGO_SUP + 10);
	push	bc
	ld	a, #0x3a
	push	af
	inc	sp
	ld	a, -1 (ix)
	push	af
	inc	sp
	push	de
	call	_cpct_getScreenPtr
	ld	de, #0x8601
	push	de
	ld	de, #0x00ff
	push	de
	push	hl
	call	_cpct_drawSolidBox
	pop	bc
00112$:
;src/map_utils.c:115: vmem_buffer = VMEM_BUFFER2;
	ld	de, #0x8000
;src/map_utils.c:107: for (j = NUM_BUFFERS; j > 0; j--) {
	ld	l, b
	dec	l
	ld	a,l
	ld	b,a
	or	a, a
	jr	NZ,00116$
;src/map_utils.c:98: for (i = 1; i < NUM_MAPAS + 1; i++) {
	inc	c
	ld	a, c
	sub	a, #0x06
	jp	C, 00118$
	ld	sp, ix
	pop	ix
	ret
;src/map_utils.c:127: void descomprimir_pintarMapa() {
;	---------------------------------
; Function descomprimir_pintarMapa
; ---------------------------------
_descomprimir_pintarMapa::
;src/map_utils.c:128: cpct_zx7b_decrunch_s((void *) (&mapa[0] + TILES_TOTALES - 1), (void *) mapa_ptr);
	ld	de, (_mapa_ptr)
	ld	bc, #_mapa+359
	push	de
	push	bc
	call	_cpct_zx7b_decrunch_s
;src/map_utils.c:129: pintarMapa();
	call	_pintarMapa
	ret
;src/map_utils.c:147: void redibujarTile(u8 x, u8 y, u8 ancho, u8 alto, u8 monoBufer) {
;	---------------------------------
; Function redibujarTile
; ---------------------------------
_redibujarTile::
	call	___sdcc_enter_ix
	push	af
;src/map_utils.c:152: x = x - (x & 3) - AREA_JUEGO_IZQ;   // x = x - (x % TL_TILESET_00_W) - AREA_JUEGO_IZQ;
	ld	a, 4 (ix)
	and	a, #0x03
	ld	c, a
	ld	a, 4 (ix)
	sub	a, c
	ld	4 (ix), a
;src/map_utils.c:153: y = y - (y & 7) - AREA_JUEGO_SUP;   // y = y - (y % TL_TILESET_00_H) - AREA_JUEGO_SUP;
	ld	a, 5 (ix)
	and	a, #0x07
	ld	c, a
	ld	a, 5 (ix)
	sub	a, c
	add	a, #0xd0
;src/map_utils.c:157: primer_tile = (y / TL_TILESET_00_H) * 20 + (x / TL_TILESET_00_W);
	ld	5 (ix), a
	rrca
	rrca
	rrca
	and	a, #0x1f
	ld	c,a
	ld	b,#0x00
	ld	l, c
	ld	h, b
	add	hl, hl
	add	hl, hl
	add	hl, bc
	add	hl, hl
	add	hl, hl
	ld	c, 4 (ix)
	srl	c
	srl	c
	ld	b, #0x00
	add	hl,bc
;src/map_utils.c:158: cpct_etm_setDrawTilemap4x8_ag (ancho, alto, 20, &tl_tileset_00[0]);
	push	hl
	ld	hl, #_tl_tileset_00
	push	hl
	ld	hl, #0x0014
	push	hl
	ld	h, 7 (ix)
	ld	l, 6 (ix)
	push	hl
	call	_cpct_etm_setDrawTilemap4x8_ag
	pop	bc
;src/map_utils.c:160: cpct_etm_drawTilemap4x8_ag((u8*) cpct_getScreenPtr (vmem_start, x + AREA_JUEGO_IZQ, y + AREA_JUEGO_SUP), &mapa[primer_tile]);
	ld	a, 5 (ix)
	add	a, #0x30
	ld	d, a
;src/map_utils.c:159: if (monoBufer) {
	ld	a, 8 (ix)
	or	a, a
	jr	Z,00102$
;src/map_utils.c:160: cpct_etm_drawTilemap4x8_ag((u8*) cpct_getScreenPtr (vmem_start, x + AREA_JUEGO_IZQ, y + AREA_JUEGO_SUP), &mapa[primer_tile]);
	ld	hl, #_mapa+0
	add	hl,bc
	ld	c, l
	ld	b, h
	ld	iy, (_vmem_start)
	push	bc
	push	de
	inc	sp
	ld	a, 4 (ix)
	push	af
	inc	sp
	push	iy
	call	_cpct_getScreenPtr
	push	hl
	call	_cpct_etm_drawTilemap4x8_ag
	jr	00104$
00102$:
;src/map_utils.c:162: cpct_etm_drawTilemap4x8_ag((u8*) cpct_getScreenPtr (VMEM_BUFFER1, x + AREA_JUEGO_IZQ, y + AREA_JUEGO_SUP), &mapa[primer_tile]);
	ld	hl, #_mapa
	add	hl,bc
	ex	(sp), hl
	pop	bc
	push	bc
	push	bc
	push	de
	push	de
	inc	sp
	ld	a, 4 (ix)
	push	af
	inc	sp
	ld	hl, #0xc000
	push	hl
	call	_cpct_getScreenPtr
	pop	de
	pop	bc
	push	de
	push	bc
	push	hl
	call	_cpct_etm_drawTilemap4x8_ag
	pop	de
;src/map_utils.c:163: cpct_etm_drawTilemap4x8_ag((u8*) cpct_getScreenPtr (VMEM_BUFFER2, x + AREA_JUEGO_IZQ, y + AREA_JUEGO_SUP), &mapa[primer_tile]);
	pop	bc
	push	bc
	push	bc
	push	de
	inc	sp
	ld	a, 4 (ix)
	push	af
	inc	sp
	ld	hl, #0x8000
	push	hl
	call	_cpct_getScreenPtr
	push	hl
	call	_cpct_etm_drawTilemap4x8_ag
00104$:
	pop	af
	pop	ix
	ret
;src/map_utils.c:178: void redibujarSwitches() {
;	---------------------------------
; Function redibujarSwitches
; ---------------------------------
_redibujarSwitches::
;src/map_utils.c:179: if (mapa_actual == 3) {
	ld	a,(#_mapa_actual + 0)
	sub	a, #0x03
	jr	NZ,00104$
;src/map_utils.c:180: redibujarTile( 4,  72,  1,  1, NO);
	ld	hl, #0x0001
	push	hl
	ld	hl, #0x0148
	push	hl
	ld	a, #0x04
	push	af
	inc	sp
	call	_redibujarTile
	pop	af
;src/map_utils.c:181: redibujarTile( 4, 168,  1,  1, NO);
	inc	sp
	ld	hl,#0x0001
	ex	(sp),hl
	ld	hl, #0x01a8
	push	hl
	ld	a, #0x04
	push	af
	inc	sp
	call	_redibujarTile
	pop	af
	pop	af
	inc	sp
	ret
00104$:
;src/map_utils.c:182: } else if (mapa_actual == 2) {
	ld	a,(#_mapa_actual + 0)
	sub	a, #0x02
	ret	NZ
;src/map_utils.c:183: redibujarTile(20,  104, 1,  1, NO);
	ld	hl, #0x0001
	push	hl
	ld	hl, #0x0168
	push	hl
	ld	a, #0x14
	push	af
	inc	sp
	call	_redibujarTile
	pop	af
;src/map_utils.c:184: redibujarTile(56,  104, 1,  1, NO);
	inc	sp
	ld	hl,#0x0001
	ex	(sp),hl
	ld	hl, #0x0168
	push	hl
	ld	a, #0x38
	push	af
	inc	sp
	call	_redibujarTile
	pop	af
	pop	af
	inc	sp
	ret
;src/map_utils.c:191: void activarSwitch() {
;	---------------------------------
; Function activarSwitch
; ---------------------------------
_activarSwitch::
;src/map_utils.c:193: if (!mapa_halt_switch) {
	ld	iy, #_mapa_halt_switch
	ld	a, 1 (iy)
	or	a,0 (iy)
	ret	NZ
;src/map_utils.c:194: mapa_halt_switch = 500;
	ld	hl, #0x01f4
	ld	(_mapa_halt_switch), hl
;src/map_utils.c:199: mapa_id_cambio = (mapa_id_cambio ? 0 : 1);
	ld	a,(#_mapa_id_cambio + 0)
	or	a, a
	jr	Z,00118$
	ld	c, #0x00
	jr	00119$
00118$:
	ld	c, #0x01
00119$:
	ld	hl,#_mapa_id_cambio + 0
	ld	(hl), c
;src/map_utils.c:201: if (mapa_actual == 3) {
	ld	a,(#_mapa_actual + 0)
	sub	a, #0x03
	jr	NZ,00104$
;src/map_utils.c:203: mapa[61] = mapa [301] = NUM_TILE_SWITCH_OFF;
	ld	hl, #(_mapa + 0x012d)
	ld	(hl), #0x06
	ld	hl, #(_mapa + 0x003d)
	ld	(hl), #0x06
;src/map_utils.c:206: n = (mapa_id_cambio ? 2 : 25);
	ld	a,(#_mapa_id_cambio + 0)
	or	a, a
	jr	Z,00120$
	ld	c, #0x02
	jr	00121$
00120$:
	ld	c, #0x19
00121$:
;src/map_utils.c:207: n2 = (mapa_id_cambio ? 25 : 2);
	ld	a,(#_mapa_id_cambio + 0)
	or	a, a
	jr	Z,00122$
	ld	b, #0x19
	jr	00123$
00122$:
	ld	b, #0x02
00123$:
;src/map_utils.c:208: mapa[146] = mapa[266] = n;
	ld	hl, #(_mapa + 0x010a)
	ld	(hl), c
	ld	hl, #(_mapa + 0x0092)
	ld	(hl), c
;src/map_utils.c:209: mapa[206] = mapa[326] = n2;
	ld	hl, #(_mapa + 0x0146)
	ld	(hl), b
	ld	hl, #(_mapa + 0x00ce)
	ld	(hl), b
	jr	00105$
00104$:
;src/map_utils.c:212: if (mapa_actual == 2) {
	ld	a,(#_mapa_actual + 0)
	sub	a, #0x02
	jr	NZ,00105$
;src/map_utils.c:214: mapa[145] = mapa [154] = NUM_TILE_SWITCH_OFF;
	ld	hl, #(_mapa + 0x009a)
	ld	(hl), #0x06
	ld	hl, #(_mapa + 0x0091)
	ld	(hl), #0x06
;src/map_utils.c:217: n = (mapa_id_cambio ? 2 : 24);
	ld	a,(#_mapa_id_cambio + 0)
	or	a, a
	jr	Z,00124$
	ld	c, #0x02
	jr	00125$
00124$:
	ld	c, #0x18
00125$:
;src/map_utils.c:218: mapa[188] = mapa[189] = mapa[190] = mapa[191] = mapa[107] = mapa[108] = mapa[109] = mapa[110] = mapa[111] = mapa[112] = n;
	ld	hl, #(_mapa + 0x0070)
	ld	(hl), c
	ld	hl, #(_mapa + 0x006f)
	ld	(hl), c
	ld	hl, #(_mapa + 0x006e)
	ld	(hl), c
	ld	hl, #(_mapa + 0x006d)
	ld	(hl), c
	ld	hl, #(_mapa + 0x006c)
	ld	(hl), c
	ld	hl, #(_mapa + 0x006b)
	ld	(hl), c
	ld	hl, #(_mapa + 0x00bf)
	ld	(hl), c
	ld	hl, #(_mapa + 0x00be)
	ld	(hl), c
	ld	hl, #(_mapa + 0x00bd)
	ld	(hl), c
	ld	hl, #(_mapa + 0x00bc)
	ld	(hl), c
00105$:
;src/map_utils.c:226: if (mapa_actual == 3) {
	ld	a,(#_mapa_actual + 0)
	sub	a, #0x03
	jr	NZ,00110$
;src/map_utils.c:227: for (n = 104; n < 178; n = n + 24) {
	ld	b, #0x68
00114$:
;src/map_utils.c:228: redibujarTile(24,  n,  1,  1, NO);
	push	bc
	ld	hl, #0x0001
	push	hl
	ld	a, #0x01
	push	af
	inc	sp
	push	bc
	inc	sp
	ld	a, #0x18
	push	af
	inc	sp
	call	_redibujarTile
	pop	af
	pop	af
	inc	sp
	pop	bc
;src/map_utils.c:227: for (n = 104; n < 178; n = n + 24) {
	ld	a, b
	add	a, #0x18
	ld	b,a
	sub	a, #0xb2
	jr	C,00114$
	jr	00111$
00110$:
;src/map_utils.c:231: if (mapa_actual == 2) {
	ld	a,(#_mapa_actual + 0)
	sub	a, #0x02
	jr	NZ,00111$
;src/map_utils.c:232: redibujarTile(32,  120,  4,  1, NO);
	ld	hl, #0x0001
	push	hl
	ld	hl, #0x0478
	push	hl
	ld	a, #0x20
	push	af
	inc	sp
	call	_redibujarTile
	pop	af
;src/map_utils.c:233: redibujarTile(28,   88,  6,  1, NO);
	inc	sp
	ld	hl,#0x0001
	ex	(sp),hl
	ld	hl, #0x0658
	push	hl
	ld	a, #0x1c
	push	af
	inc	sp
	call	_redibujarTile
	pop	af
	pop	af
	inc	sp
00111$:
;src/map_utils.c:235: redibujarSwitches();
	call	_redibujarSwitches
;src/map_utils.c:236: playSFX(1,25);
	ld	hl, #0x1901
	push	hl
	call	_playSFX
	pop	af
	ret
;src/map_utils.c:244: void reactivarSwitch() {
;	---------------------------------
; Function reactivarSwitch
; ---------------------------------
_reactivarSwitch::
;src/map_utils.c:245: mapa_halt_switch = 0;
	ld	hl, #0x0000
	ld	(_mapa_halt_switch), hl
;src/map_utils.c:246: if (mapa_actual == 3) {
	ld	a,(#_mapa_actual + 0)
	sub	a, #0x03
	jr	NZ,00104$
;src/map_utils.c:247: mapa[61] = mapa [301] = NUM_TILE_SWITCH_ON;
	ld	hl, #(_mapa + 0x012d)
	ld	(hl), #0x0b
	ld	hl, #(_mapa + 0x003d)
	ld	(hl), #0x0b
	jp	_redibujarSwitches
00104$:
;src/map_utils.c:248: } else if (mapa_actual == 2) {
	ld	a,(#_mapa_actual + 0)
	sub	a, #0x02
	jp	NZ,_redibujarSwitches
;src/map_utils.c:249: mapa[145] = mapa [154] = NUM_TILE_SWITCH_ON;
	ld	hl, #(_mapa + 0x009a)
	ld	(hl), #0x0b
	ld	hl, #(_mapa + 0x0091)
	ld	(hl), #0x0b
;src/map_utils.c:251: redibujarSwitches();
	jp  _redibujarSwitches
;src/map_utils.c:265: u16 tileCell(u8 x, u8 y) {
;	---------------------------------
; Function tileCell
; ---------------------------------
_tileCell::
	call	___sdcc_enter_ix
;src/map_utils.c:266: return ((MAPA_W * ( (y - AREA_JUEGO_SUP) / TL_TILESET_00_H ) ) + ((x - AREA_JUEGO_IZQ) / TL_TILESET_00_W));
	ld	c, 5 (ix)
	ld	b, #0x00
	ld	a, c
	add	a, #0xd0
	ld	e, a
	ld	a, b
	adc	a, #0xff
	ld	d, a
	ld	l, e
	ld	h, d
	bit	7, d
	jr	Z,00103$
	ld	hl, #0xffd7
	add	hl, bc
00103$:
	ld	b, #0x03
00113$:
	sra	h
	rr	l
	djnz	00113$
	ld	c, l
	ld	b, h
	add	hl, hl
	add	hl, hl
	add	hl, bc
	add	hl, hl
	add	hl, hl
	ld	c, l
	ld	e, 4 (ix)
	ld	d, #0x00
	ld	l, e
	ld	b, d
	bit	7, d
	jr	Z,00104$
	inc	de
	inc	de
	inc	de
	ld	l, e
	ld	b, d
00104$:
	sra	b
	rr	l
	sra	b
	rr	l
	add	hl, bc
	pop	ix
	ret
;src/map_utils.c:280: u8 tileValue(u8 x, u8 y) {
;	---------------------------------
; Function tileValue
; ---------------------------------
_tileValue::
	call	___sdcc_enter_ix
;src/map_utils.c:281: return mapa[tileCell(x, y)];
	ld	h, 5 (ix)
	ld	l, 4 (ix)
	push	hl
	call	_tileCell
	pop	af
	ld	de, #_mapa
	add	hl, de
	ld	l, (hl)
	pop	ix
	ret
;src/map_utils.c:304: u8 typeOfTile(u8 tile) {
;	---------------------------------
; Function typeOfTile
; ---------------------------------
_typeOfTile::
;src/map_utils.c:305: if (tile == NUM_TILE_SWITCH) activarSwitch();
	ld	hl, #2+0
	add	hl, sp
	ld	a, (hl)
	sub	a, #0x0b
	jr	NZ,00102$
	call	_activarSwitch
00102$:
;src/map_utils.c:306: if (tile > PRIMER_TILE_OBSTACULO)
	ld	a, #0x16
	ld	iy, #2
	add	iy, sp
	sub	a, 0 (iy)
	jr	NC,00113$
;src/map_utils.c:307: return OBSTACULO;
	ld	l, #0x05
	ret
00113$:
;src/map_utils.c:308: else if (tile > PRIMER_TILE_PLATAFORMA)
	ld	a, #0x0f
	ld	iy, #2
	add	iy, sp
	sub	a, 0 (iy)
	jr	NC,00110$
;src/map_utils.c:309: return PLATAFORMA;
	ld	l, #0x04
	ret
00110$:
;src/map_utils.c:310: else if (tile > PRIMER_TILE_ESCALERA)
	ld	a, #0x0b
	ld	iy, #2
	add	iy, sp
	sub	a, 0 (iy)
	jr	NC,00107$
;src/map_utils.c:311: return ESCALERAS;
	ld	l, #0x03
	ret
00107$:
;src/map_utils.c:312: else if (tile > PRIMER_TILE_PINCHOS)
	ld	a, #0x09
	ld	iy, #2
	add	iy, sp
	sub	a, 0 (iy)
	jr	NC,00104$
;src/map_utils.c:313: return PINCHOS;
	ld	l, #0x01
	ret
00104$:
;src/map_utils.c:315: return NADA;
	ld	l, #0x00
	ret
	.area _CODE
	.area _INITIALIZER
	.area _CABS (ABS)
