;--------------------------------------------------------
; File Created by SDCC : free open source ANSI-C Compiler
; Version 3.6.8 #9946 (CYGWIN)
;--------------------------------------------------------
	.module teclado
	.optsdcc -mz80
	
;--------------------------------------------------------
; Public variables in this module
;--------------------------------------------------------
	.globl _redefineKey
	.globl _esperaUnaTecla
	.globl _teclado
	.globl _vaciaBufferTeclado
	.globl _printTxt
	.globl _sonidoTecla
	.globl _disparar
	.globl _cpct_getScreenPtr
	.globl _cpct_drawSolidBox
	.globl _cpct_isAnyKeyPressed
	.globl _cpct_isKeyPressed
	.globl _cpct_scanKeyboard
;--------------------------------------------------------
; special function registers
;--------------------------------------------------------
;--------------------------------------------------------
; ram data
;--------------------------------------------------------
	.area _DATA
;--------------------------------------------------------
; ram data
;--------------------------------------------------------
	.area _INITIALIZED
;--------------------------------------------------------
; absolute external ram data
;--------------------------------------------------------
	.area _DABS (ABS)
;--------------------------------------------------------
; global & static initialisations
;--------------------------------------------------------
	.area _HOME
	.area _GSINIT
	.area _GSFINAL
	.area _GSINIT
;--------------------------------------------------------
; Home
;--------------------------------------------------------
	.area _HOME
	.area _HOME
;--------------------------------------------------------
; code
;--------------------------------------------------------
	.area _CODE
;src/teclado.c:12: void vaciaBufferTeclado() {
;	---------------------------------
; Function vaciaBufferTeclado
; ---------------------------------
_vaciaBufferTeclado::
;src/teclado.c:13: while (cpct_isAnyKeyPressed()) {
00101$:
	call	_cpct_isAnyKeyPressed
	ld	a, l
	or	a, a
	ret	Z
;src/teclado.c:14: cpct_scanKeyboard();
	call	_cpct_scanKeyboard
	jr	00101$
;src/teclado.c:21: void teclado() {
;	---------------------------------
; Function teclado
; ---------------------------------
_teclado::
;src/teclado.c:24: jugador[0].movimientoV = jugador[0].movimientoH = jugador[1].movimientoV = jugador[1].movimientoH = 0;
	ld	hl, #(_jugador + 0x0028)
	ld	(hl), #0x00
	ld	hl, #(_jugador + 0x0029)
	ld	(hl), #0x00
	ld	hl, #(_jugador + 0x0002)
	ld	(hl), #0x00
	ld	hl, #(_jugador + 0x0003)
	ld	(hl), #0x00
;src/teclado.c:27: cpct_scanKeyboard();
	call	_cpct_scanKeyboard
;src/teclado.c:33: if (!jugador[0].disparando) {
	ld	a, (#_jugador + 27)
	or	a, a
	jp	NZ, 00127$
;src/teclado.c:34: if (cpct_isKeyPressed(key[0].up) || cpct_isKeyPressed(Joy1_Up)) {
	ld	hl, (#_key + 0)
	call	_cpct_isKeyPressed
	ld	a, l
	or	a, a
	jr	NZ,00108$
	ld	hl, #0x0106
	call	_cpct_isKeyPressed
	ld	a, l
	or	a, a
	jr	Z,00109$
00108$:
;src/teclado.c:35: jugador[0].movimientoV = ARRIBA;
	ld	hl, #(_jugador + 0x0003)
	ld	(hl), #0xff
;src/teclado.c:36: if (bitOptions & mask_player0_inverse) jugador[0].movimientoV = ABAJO;
	ld	hl,#_bitOptions+0
	bit	4, (hl)
	jr	Z,00110$
	ld	hl, #(_jugador + 0x0003)
	ld	(hl), #0x01
	jr	00110$
00109$:
;src/teclado.c:38: if (cpct_isKeyPressed(key[0].down) || cpct_isKeyPressed(Joy1_Down)) {
	ld	hl, (#(_key + 0x0002) + 0)
	call	_cpct_isKeyPressed
	ld	a, l
	or	a, a
	jr	NZ,00105$
	ld	hl, #0x0206
	call	_cpct_isKeyPressed
	ld	a, l
	or	a, a
	jr	Z,00110$
00105$:
;src/teclado.c:39: jugador[0].movimientoV = ABAJO;
	ld	hl, #(_jugador + 0x0003)
	ld	(hl), #0x01
;src/teclado.c:40: if (bitOptions & mask_player0_inverse) jugador[0].movimientoV = ARRIBA;
	ld	hl,#_bitOptions+0
	bit	4, (hl)
	jr	Z,00110$
	ld	hl, #(_jugador + 0x0003)
	ld	(hl), #0xff
00110$:
;src/teclado.c:42: if (cpct_isKeyPressed(key[0].left) || cpct_isKeyPressed(Joy1_Left)) {
	ld	hl, (#_key + 4)
	call	_cpct_isKeyPressed
;src/teclado.c:44: jugador[0].direccion = mask_direccion_izq;
;src/teclado.c:42: if (cpct_isKeyPressed(key[0].left) || cpct_isKeyPressed(Joy1_Left)) {
	ld	a, l
	or	a, a
	jr	NZ,00119$
	ld	hl, #0x0406
	call	_cpct_isKeyPressed
	ld	a, l
	or	a, a
	jr	Z,00120$
00119$:
;src/teclado.c:43: jugador[0].movimientoH = IZQUIERDA;
	ld	hl, #(_jugador + 0x0002)
	ld	(hl), #0xff
;src/teclado.c:44: jugador[0].direccion = mask_direccion_izq;
	ld	hl, #(_jugador + 0x0017)
	ld	(hl), #0x02
;src/teclado.c:45: if (bitOptions & mask_player0_inverse) {
	ld	hl,#_bitOptions+0
	bit	4, (hl)
	jr	Z,00121$
;src/teclado.c:46: jugador[0].movimientoH = DERECHA;
	ld	hl, #(_jugador + 0x0002)
	ld	(hl), #0x01
;src/teclado.c:47: jugador[0].direccion = mask_direccion_der;
	ld	hl, #(_jugador + 0x0017)
	ld	(hl), #0x01
	jr	00121$
00120$:
;src/teclado.c:50: if (cpct_isKeyPressed(key[0].right) || cpct_isKeyPressed(Joy1_Right)) {
	ld	hl, (#_key + 6)
	call	_cpct_isKeyPressed
	ld	a, l
	or	a, a
	jr	NZ,00116$
	ld	hl, #0x0806
	call	_cpct_isKeyPressed
	ld	a, l
	or	a, a
	jr	Z,00121$
00116$:
;src/teclado.c:51: jugador[0].movimientoH = DERECHA;
	ld	hl, #(_jugador + 0x0002)
	ld	(hl), #0x01
;src/teclado.c:52: jugador[0].direccion =  mask_direccion_der;
	ld	hl, #(_jugador + 0x0017)
	ld	(hl), #0x01
;src/teclado.c:53: if (bitOptions & mask_player0_inverse) {
	ld	hl,#_bitOptions+0
	bit	4, (hl)
	jr	Z,00121$
;src/teclado.c:54: jugador[0].movimientoH = IZQUIERDA;
	ld	hl, #(_jugador + 0x0002)
	ld	(hl), #0xff
;src/teclado.c:55: jugador[0].direccion = mask_direccion_izq;
	ld	hl, #(_jugador + 0x0017)
	ld	(hl), #0x02
00121$:
;src/teclado.c:58: if (cpct_isKeyPressed(key[0].fire) || cpct_isKeyPressed(Joy1_Fire1)) {
	ld	hl, (#_key + 8)
	call	_cpct_isKeyPressed
	ld	a, l
	or	a, a
	jr	NZ,00123$
	ld	hl, #0x1006
	call	_cpct_isKeyPressed
	ld	a, l
	or	a, a
	jr	Z,00127$
00123$:
;src/teclado.c:59: disparar(0);
	xor	a, a
	push	af
	inc	sp
	call	_disparar
	inc	sp
00127$:
;src/teclado.c:68: if (!jugador[1].disparando) {
	ld	a,(#_jugador + 65)
	or	a, a
	jp	NZ, 00154$
;src/teclado.c:69: if (cpct_isKeyPressed(key[1].up) || cpct_isKeyPressed(Joy0_Up)) {
	ld	hl, (#_key + 10)
	call	_cpct_isKeyPressed
	ld	a, l
	or	a, a
	jr	NZ,00135$
	ld	hl, #0x0109
	call	_cpct_isKeyPressed
	ld	a, l
	or	a, a
	jr	Z,00136$
00135$:
;src/teclado.c:70: jugador[1].movimientoV = ARRIBA;
	ld	hl, #(_jugador + 0x0029)
	ld	(hl), #0xff
;src/teclado.c:71: if (bitOptions & mask_player1_inverse) jugador[1].movimientoV = ABAJO;
	ld	hl,#_bitOptions+0
	bit	3, (hl)
	jr	Z,00137$
	ld	hl, #(_jugador + 0x0029)
	ld	(hl), #0x01
	jr	00137$
00136$:
;src/teclado.c:73: if (cpct_isKeyPressed(key[1].down) || cpct_isKeyPressed(Joy0_Down)) {
	ld	hl, (#_key + 12)
	call	_cpct_isKeyPressed
	ld	a, l
	or	a, a
	jr	NZ,00132$
	ld	hl, #0x0209
	call	_cpct_isKeyPressed
	ld	a, l
	or	a, a
	jr	Z,00137$
00132$:
;src/teclado.c:74: jugador[1].movimientoV = ABAJO;
	ld	hl, #(_jugador + 0x0029)
	ld	(hl), #0x01
;src/teclado.c:75: if (bitOptions & mask_player1_inverse) jugador[1].movimientoV = ARRIBA;
	ld	hl,#_bitOptions+0
	bit	3, (hl)
	jr	Z,00137$
	ld	hl, #(_jugador + 0x0029)
	ld	(hl), #0xff
00137$:
;src/teclado.c:77: if (cpct_isKeyPressed(key[1].left) || cpct_isKeyPressed(Joy0_Left)) {
	ld	hl, (#_key + 14)
	call	_cpct_isKeyPressed
;src/teclado.c:79: jugador[1].direccion = mask_direccion_izq;
;src/teclado.c:77: if (cpct_isKeyPressed(key[1].left) || cpct_isKeyPressed(Joy0_Left)) {
	ld	a, l
	or	a, a
	jr	NZ,00146$
	ld	hl, #0x0409
	call	_cpct_isKeyPressed
	ld	a, l
	or	a, a
	jr	Z,00147$
00146$:
;src/teclado.c:78: jugador[1].movimientoH = IZQUIERDA;
	ld	hl, #(_jugador + 0x0028)
	ld	(hl), #0xff
;src/teclado.c:79: jugador[1].direccion = mask_direccion_izq;
	ld	hl, #(_jugador + 0x003d)
	ld	(hl), #0x02
;src/teclado.c:80: if (bitOptions & mask_player1_inverse) {
	ld	hl,#_bitOptions+0
	bit	3, (hl)
	jr	Z,00148$
;src/teclado.c:81: jugador[1].movimientoH = DERECHA;
	ld	hl, #(_jugador + 0x0028)
	ld	(hl), #0x01
;src/teclado.c:82: jugador[1].direccion = mask_direccion_der;
	ld	hl, #(_jugador + 0x003d)
	ld	(hl), #0x01
	jr	00148$
00147$:
;src/teclado.c:85: if (cpct_isKeyPressed(key[1].right) || cpct_isKeyPressed(Joy0_Right)) {
	ld	hl, (#_key + 16)
	call	_cpct_isKeyPressed
	ld	a, l
	or	a, a
	jr	NZ,00143$
	ld	hl, #0x0809
	call	_cpct_isKeyPressed
	ld	a, l
	or	a, a
	jr	Z,00148$
00143$:
;src/teclado.c:86: jugador[1].movimientoH = DERECHA;
	ld	hl, #(_jugador + 0x0028)
	ld	(hl), #0x01
;src/teclado.c:87: jugador[1].direccion = mask_direccion_der;
	ld	hl, #(_jugador + 0x003d)
	ld	(hl), #0x01
;src/teclado.c:88: if (bitOptions & mask_player1_inverse) {
	ld	hl,#_bitOptions+0
	bit	3, (hl)
	jr	Z,00148$
;src/teclado.c:89: jugador[1].movimientoH = IZQUIERDA;
	ld	hl, #(_jugador + 0x0028)
	ld	(hl), #0xff
;src/teclado.c:90: jugador[1].direccion = mask_direccion_izq;
	ld	hl, #(_jugador + 0x003d)
	ld	(hl), #0x02
00148$:
;src/teclado.c:93: if (cpct_isKeyPressed(key[1].fire) || cpct_isKeyPressed(Joy0_Fire1)) {
	ld	hl, (#_key + 18)
	call	_cpct_isKeyPressed
	ld	a, l
	or	a, a
	jr	NZ,00150$
	ld	hl, #0x1009
	call	_cpct_isKeyPressed
	ld	a, l
	or	a, a
	jr	Z,00154$
00150$:
;src/teclado.c:94: disparar(1);
	ld	a, #0x01
	push	af
	inc	sp
	call	_disparar
	inc	sp
00154$:
;src/teclado.c:103: if (cpct_isKeyPressed(Key_Esc)) {
	ld	hl, #0x0408
	call	_cpct_isKeyPressed
	ld	a, l
	or	a, a
	ret	Z
;src/teclado.c:104: backToMenu = 1;     
	ld	hl,#_backToMenu + 0
	ld	(hl), #0x01
	ret
;src/teclado.c:138: cpct_keyID esperaUnaTecla() {
;	---------------------------------
; Function esperaUnaTecla
; ---------------------------------
_esperaUnaTecla::
;src/teclado.c:141: u8 i = 10, *keys = cpct_keyboardStatusBuffer + 9;
	ld	b, #0x0a
;src/teclado.c:145: do { cpct_scanKeyboard(); 
00101$:
	push	bc
	call	_cpct_scanKeyboard
	call	_cpct_isAnyKeyPressed
	pop	bc
	ld	a, l
	or	a, a
	jr	Z,00101$
;src/teclado.c:149: do {
	ld	iy, #(_cpct_keyboardStatusBuffer + 0x0009)
	ld	c, #0x0a
00106$:
;src/teclado.c:152: keypressed = *keys ^ 0xFF;
	ld	a, 0 (iy)
	xor	a, #0xff
	ld	e, a
	ld	d, #0x00
;src/teclado.c:154: return (keypressed << 8) + (i - 1);  // Formato cpct_keyID: 8 primeros bits = máscara de tecla, 8 siguientes fila del teclado (0-9)
	ld	h, e
	ld	l, #0x00
;src/teclado.c:153: if (keypressed)
	ld	a, d
	or	a,e
	jr	Z,00105$
;src/teclado.c:154: return (keypressed << 8) + (i - 1);  // Formato cpct_keyID: 8 primeros bits = máscara de tecla, 8 siguientes fila del teclado (0-9)
	ld	c, b
	ld	b, #0x00
	dec	bc
	add	hl, bc
	ret
00105$:
;src/teclado.c:155: keys--;
	dec	iy
;src/teclado.c:156: } while (--i);
	dec	c
	ld	a,c
	ld	b,a
;src/teclado.c:157: return (keypressed << 8) + (i - 1);
	or	a,a
	jr	NZ,00106$
	ld	b,a
	dec	bc
	add	hl,bc
	ret
;src/teclado.c:160: cpct_keyID redefineKey(u8 text[]){
;	---------------------------------
; Function redefineKey
; ---------------------------------
_redefineKey::
;src/teclado.c:162: cpct_drawSolidBox(cpct_getScreenPtr((VMEM_BUFFER1), 35, 120), 0, 12, 8);
	ld	hl, #0x7823
	push	hl
	ld	hl, #0xc000
	push	hl
	call	_cpct_getScreenPtr
	ld	bc, #0x080c
	push	bc
	ld	bc, #0x0000
	push	bc
	push	hl
	call	_cpct_drawSolidBox
;src/teclado.c:163: printTxt(text, CENTRADO, 120, NO, 0);
	ld	hl, #0x0000
	push	hl
	ld	h, #0x78
	push	hl
	ld	hl, #6
	add	hl, sp
	ld	c, (hl)
	inc	hl
	ld	b, (hl)
	push	bc
	call	_printTxt
	pop	af
	pop	af
	pop	af
;src/teclado.c:164: vaciaBufferTeclado();
	call	_vaciaBufferTeclado
;src/teclado.c:165: key = esperaUnaTecla();
	call	_esperaUnaTecla
;src/teclado.c:166: sonidoTecla();
	push	hl
	call	_sonidoTecla
	call	_vaciaBufferTeclado
	pop	hl
;src/teclado.c:168: return key;
	ret
	.area _CODE
	.area _INITIALIZER
	.area _CABS (ABS)
