;--------------------------------------------------------
; File Created by SDCC : free open source ANSI-C Compiler
; Version 3.6.8 #9946 (CYGWIN)
;--------------------------------------------------------
	.module gui
	.optsdcc -mz80
	
;--------------------------------------------------------
; Public variables in this module
;--------------------------------------------------------
	.globl _drawStats
	.globl _printInt
	.globl _printTxt
	.globl _vaciaBufferTeclado
	.globl _sonidoTecla
	.globl _reproducirMusica
	.globl _pintarRecuadroDoble
	.globl _cpct_zx7b_decrunch_s
	.globl _cpct_akp_musicInit
	.globl _cpct_getScreenPtr
	.globl _cpct_drawSprite
	.globl _cpct_drawSolidBox
	.globl _cpct_px2byteM0
	.globl _cpct_isKeyPressed
	.globl _cpct_scanKeyboard
	.globl _cpct_memcpy
	.globl _modificaMarcadorVida
	.globl _modificaMarcadorHechizos
	.globl _pintarCaraJugador
	.globl _escribirNombreJugador
	.globl _pintarIconosMarcador
	.globl _pintarMuro
	.globl _pintarMarcadorSuperior
	.globl _gameOverScreen
;--------------------------------------------------------
; special function registers
;--------------------------------------------------------
;--------------------------------------------------------
; ram data
;--------------------------------------------------------
	.area _DATA
;--------------------------------------------------------
; ram data
;--------------------------------------------------------
	.area _INITIALIZED
;--------------------------------------------------------
; absolute external ram data
;--------------------------------------------------------
	.area _DABS (ABS)
;--------------------------------------------------------
; global & static initialisations
;--------------------------------------------------------
	.area _HOME
	.area _GSINIT
	.area _GSFINAL
	.area _GSINIT
;--------------------------------------------------------
; Home
;--------------------------------------------------------
	.area _HOME
	.area _HOME
;--------------------------------------------------------
; code
;--------------------------------------------------------
	.area _CODE
;src/gui.c:29: void modificaMarcadorVida(u8 j, i8 n) {
;	---------------------------------
; Function modificaMarcadorVida
; ---------------------------------
_modificaMarcadorVida::
	call	___sdcc_enter_ix
	dec	sp
;src/gui.c:30: jugador[j].vidas = ((jugador[j].vidas + n) > MAX_VIDAS ? MAX_VIDAS : jugador[j].vidas + n);
	ld	bc, #_jugador+0
	ld	e,4 (ix)
	ld	d,#0x00
	ld	l, e
	ld	h, d
	add	hl, hl
	add	hl, hl
	add	hl, hl
	add	hl, de
	add	hl, hl
	add	hl, de
	add	hl, hl
	add	hl,bc
	ld	bc,#0x001a
	add	hl,bc
	ld	c, l
	ld	b, h
	ld	a, (bc)
	ld	-1 (ix), a
	ld	e, a
	ld	a, -1 (ix)
	rla
	sbc	a, a
	ld	d, a
	ld	l, 5 (ix)
	ld	a, 5 (ix)
	rla
	sbc	a, a
	ld	h, a
	add	hl, de
	ld	a, #0x05
	cp	a, l
	ld	a, #0x00
	sbc	a, h
	jp	PO, 00109$
	xor	a, #0x80
00109$:
	jp	P, 00103$
	ld	a, #0x05
	jr	00104$
00103$:
	ld	a, -1 (ix)
	add	a, 5 (ix)
00104$:
	ld	(bc), a
;src/gui.c:31: pintarIconosMarcador(j, ICONO_VIDA);
	ld	a, #0x01
	push	af
	inc	sp
	ld	a, 4 (ix)
	push	af
	inc	sp
	call	_pintarIconosMarcador
	pop	af
	inc	sp
	pop	ix
	ret
;src/gui.c:41: void modificaMarcadorHechizos(u8 j, i8 n) {
;	---------------------------------
; Function modificaMarcadorHechizos
; ---------------------------------
_modificaMarcadorHechizos::
	call	___sdcc_enter_ix
	push	af
;src/gui.c:42: jugador[j].hechizos = ((jugador[j].hechizos + n) > MAX_HECHIZOS ? MAX_HECHIZOS : jugador[j].hechizos + n);
	ld	bc, #_jugador+0
	ld	e,4 (ix)
	ld	d,#0x00
	ld	l, e
	ld	h, d
	add	hl, hl
	add	hl, hl
	add	hl, hl
	add	hl, de
	add	hl, hl
	add	hl, de
	add	hl, hl
	add	hl, bc
	ld	bc, #0x0019
	add	hl, bc
	ld	c, (hl)
	ld	-2 (ix), c
	ld	a, c
	rla
	sbc	a, a
	ld	-1 (ix), a
	ld	b, 5 (ix)
	ld	a, 5 (ix)
	rla
	sbc	a, a
	ld	e, a
	ld	a, -2 (ix)
	add	a, b
	ld	b, a
	ld	a, -1 (ix)
	adc	a, e
	ld	e, a
	ld	a, #0x05
	cp	a, b
	ld	a, #0x00
	sbc	a, e
	jp	PO, 00115$
	xor	a, #0x80
00115$:
	jp	P, 00105$
	ld	c, #0x05
	jr	00106$
00105$:
	ld	a, c
	add	a, 5 (ix)
	ld	c, a
00106$:
	ld	(hl), c
;src/gui.c:43: if (jugador[j].hechizos < 0) jugador[j].hechizos = 0;
	bit	7, c
	jr	Z,00102$
	ld	(hl), #0x00
00102$:
;src/gui.c:44: pintarIconosMarcador(j, ICONO_HECHIZO);
	xor	a, a
	push	af
	inc	sp
	ld	a, 4 (ix)
	push	af
	inc	sp
	call	_pintarIconosMarcador
	pop	af
	pop	af
	pop	ix
	ret
;src/gui.c:62: void pintarCaraJugador(u8 j) {
;	---------------------------------
; Function pintarCaraJugador
; ---------------------------------
_pintarCaraJugador::
	call	___sdcc_enter_ix
	ld	hl, #-344
	add	hl, sp
	ld	sp, hl
;src/gui.c:67: u8* vmem_bufer = VMEM_BUFFER1;
	ld	-3 (ix), #0x00
	ld	-2 (ix), #0xc0
;src/gui.c:70: sprite  = (u8*) cara_mago0_end;
	ld	de, #_cara_mago0+201
;src/gui.c:71: if (jugador[j].skin == SKIN_MAGO1) { sprite = (u8*) cara_mago1_end; } else
	ld	c,4 (ix)
	ld	b,#0x00
	ld	l, c
	ld	h, b
	add	hl, hl
	add	hl, hl
	add	hl, hl
	add	hl, bc
	add	hl, hl
	add	hl, bc
	add	hl, hl
	ld	bc, #_jugador
	add	hl, bc
	ld	bc, #0x001e
	add	hl, bc
	ld	a, (hl)
	cp	a, #0x01
	jr	NZ,00113$
	ld	de, #(_cara_mago1 + 0x00cf)
	jr	00114$
00113$:
;src/gui.c:72: if (jugador[j].skin == SKIN_LARCENAS) { sprite = (u8*) cara_larcenas_end; } else
	cp	a, #0x02
	jr	NZ,00110$
	ld	de, #(_cara_larcenas + 0x00b5)
	jr	00114$
00110$:
;src/gui.c:73: if (jugador[j].skin == SKIN_RANA) { sprite = (u8*) cara_rana_end; } else
	cp	a, #0x03
	jr	NZ,00107$
	ld	de, #(_cara_rana + 0x00c4)
	jr	00114$
00107$:
;src/gui.c:74: if (jugador[j].skin == SKIN_ZOMBIE) { sprite = (u8*) cara_zombie_end; } else 
	cp	a, #0x04
	jr	NZ,00104$
	ld	de, #(_cara_zombie + 0x00c9)
	jr	00114$
00104$:
;src/gui.c:75: if (jugador[j].skin == SKIN_BRUJA) { sprite = (u8*) cara_bruja_end; }
	sub	a, #0x05
	jr	NZ,00114$
	ld	de, #(_cara_bruja + 0x00d3)
00114$:
;src/gui.c:77: cpct_zx7b_decrunch_s((void *) (&cara_temp[0] + cara_mago0_size - 1), sprite);
	ld	hl, #0x0000
	add	hl, sp
	ld	c, l
	ld	b, h
	ld	hl, #0x0153
	add	hl, bc
	push	bc
	push	de
	push	hl
	call	_cpct_zx7b_decrunch_s
	pop	bc
;src/gui.c:79: for (i = NUM_BUFFERS; i > 0; i--) {
	ld	-4 (ix), #0x02
	ld	a, 4 (ix)
	ld	e, a
	add	a, a
	add	a, a
	add	a, a
	add	a, a
	add	a, a
	add	a, e
	add	a, a
	add	a, #0x02
	ld	-1 (ix), a
00116$:
;src/gui.c:80: vmem_actual = cpct_getScreenPtr(vmem_bufer, X_CARA_PLAYER_1 + (j * (X_CARA_PLAYER_2 - X_CARA_PLAYER_1)), Y_CARA_PLAYERS);
	ld	e,-3 (ix)
	ld	d,-2 (ix)
	push	bc
	ld	a, #0x05
	push	af
	inc	sp
	ld	a, -1 (ix)
	push	af
	inc	sp
	push	de
	call	_cpct_getScreenPtr
	pop	bc
;src/gui.c:81: cpct_drawSprite(cara_temp, vmem_actual, SP_CARA_MAGO0_W, SP_CARA_MAGO0_H);
	push	bc
	pop	iy
	push	bc
	ld	de, #0x220a
	push	de
	push	hl
	push	iy
	call	_cpct_drawSprite
	pop	bc
;src/gui.c:82: vmem_bufer = VMEM_BUFFER2;
	ld	-3 (ix), #0x00
	ld	-2 (ix), #0x80
;src/gui.c:79: for (i = NUM_BUFFERS; i > 0; i--) {
	dec	-4 (ix)
	ld	a, -4 (ix)
	or	a, a
	jr	NZ,00116$
;src/gui.c:85: escribirNombreJugador(j);
	ld	a, 4 (ix)
	push	af
	inc	sp
	call	_escribirNombreJugador
	ld	sp,ix
	pop	ix
	ret
;src/gui.c:97: void escribirNombreJugador(u8 j) {
;	---------------------------------
; Function escribirNombreJugador
; ---------------------------------
_escribirNombreJugador::
	call	___sdcc_enter_ix
;src/gui.c:99: printTxt(nomPersonajes[jugador[j].skin], (j ? X_MARCADOR_PLAYER_2 : X_MARCADOR_PLAYER_1), Y_MARCADOR_SPELL + 1, NO, 0);
	ld	a, 4 (ix)
	or	a, a
	jr	Z,00103$
	ld	d, #0x2e
	jr	00104$
00103$:
	ld	d, #0x0e
00104$:
	ld	c,4 (ix)
	ld	b,#0x00
	ld	l, c
	ld	h, b
	add	hl, hl
	add	hl, hl
	add	hl, hl
	add	hl, bc
	add	hl, hl
	add	hl, bc
	add	hl, hl
	ld	bc, #_jugador
	add	hl, bc
	ld	bc, #0x001e
	add	hl, bc
	ld	c, (hl)
	ld	b,#0x00
	ld	l, c
	ld	h, b
	add	hl, hl
	add	hl, hl
	add	hl, bc
	add	hl, hl
	add	hl, bc
	ld	bc, #_nomPersonajes
	add	hl, bc
	ld	c, l
	ld	b, h
	ld	hl, #0x0000
	push	hl
	ld	a, #0x19
	push	af
	inc	sp
	push	de
	inc	sp
	push	bc
	call	_printTxt
	pop	af
	pop	af
	pop	af
	pop	ix
	ret
;src/gui.c:109: void pintarIconosMarcador(u8 j, u8 icono) {
;	---------------------------------
; Function pintarIconosMarcador
; ---------------------------------
_pintarIconosMarcador::
	call	___sdcc_enter_ix
	ld	hl, #-14
	add	hl, sp
	ld	sp, hl
;src/gui.c:113: u8* vmem_bufer = (u8*) 0x8000;
	ld	hl, #0x8000
	ex	(sp), hl
;src/gui.c:115: sprite = (u8*) &sp_corazon[0];
	ld	-12 (ix), #<(_sp_corazon)
	ld	-11 (ix), #>(_sp_corazon)
;src/gui.c:116: y = Y_MARCADOR_LIFE;
	ld	-10 (ix), #0x0f
;src/gui.c:118: if (!icono) {
	ld	a, 5 (ix)
	or	a, a
	jr	NZ,00102$
;src/gui.c:119: sprite = (u8*) &sp_hechizo_0[0];
	ld	-12 (ix), #<(_sp_hechizo_0)
	ld	-11 (ix), #>(_sp_hechizo_0)
;src/gui.c:120: y = Y_MARCADOR_SHOTS;
	ld	-10 (ix), #0x06
00102$:
;src/gui.c:124: bufers = NUM_BUFFERS;
	ld	-9 (ix), #0x02
;src/gui.c:125: do {
	ld	bc, #_jugador+0
	ld	e,4 (ix)
	ld	d,#0x00
	ld	l, e
	ld	h, d
	add	hl, hl
	add	hl, hl
	add	hl, hl
	add	hl, de
	add	hl, hl
	add	hl, de
	add	hl, hl
	add	hl, bc
	ld	-2 (ix), l
	ld	-1 (ix), h
	ld	-4 (ix), l
	ld	-3 (ix), h
	ld	a, 4 (ix)
	rrca
	rrca
	rrca
	and	a, #0xe0
	ld	c,a
	add	a, #0x0e
	ld	-5 (ix), a
	ld	a, 4 (ix)
	add	a, a
	add	a, a
	ld	-6 (ix), a
00106$:
;src/gui.c:127: i = (icono ? jugador[j].vidas : jugador[j].hechizos);
	ld	a, 5 (ix)
	or	a, a
	jr	Z,00111$
	ld	l,-4 (ix)
	ld	h,-3 (ix)
	ld	de, #0x001a
	add	hl, de
	ld	b, (hl)
	jr	00112$
00111$:
	ld	l,-2 (ix)
	ld	h,-1 (ix)
	ld	de, #0x0019
	add	hl, de
	ld	b, (hl)
00112$:
;src/gui.c:129: vmem_actual = cpct_getScreenPtr(vmem_bufer, x + ((X_MARCADOR_PLAYER_2 - X_MARCADOR_PLAYER_1) * j), y);
	ld	a, -14 (ix)
	ld	-8 (ix), a
	ld	a, -13 (ix)
	ld	-7 (ix), a
	push	bc
	ld	h, -10 (ix)
	ld	l, -5 (ix)
	push	hl
	ld	l,-8 (ix)
	ld	h,-7 (ix)
	push	hl
	call	_cpct_getScreenPtr
	ld	de, #0x0714
	push	de
	ld	de, #0x0000
	push	de
	push	hl
	call	_cpct_drawSolidBox
	pop	bc
;src/gui.c:131: while (i > 0) {
00103$:
	ld	a, b
	or	a, a
	jr	Z,00105$
;src/gui.c:132: vmem_actual = cpct_getScreenPtr(vmem_bufer, x + (j == 0 ? ((MAX_HECHIZOS - i) * (SP_HECHIZO_0_W)) : (SP_HECHIZO_0_W * i)) + ((X_MARCADOR_PLAYER_2-X_MARCADOR_PLAYER_1) * j) - (SP_HECHIZO_0_W * j), y);
	ld	a, 4 (ix)
	or	a, a
	jr	NZ,00113$
	ld	a, #0x05
	sub	a, b
	add	a, a
	add	a, a
	ld	l, a
	jr	00114$
00113$:
	ld	a, b
	add	a, a
	add	a, a
	ld	l, a
00114$:
	ld	e, #0x0e
	add	hl, de
	add	hl, bc
	ld	a, l
	sub	a, -6 (ix)
	ld	d, a
	push	bc
	ld	a, -10 (ix)
	push	af
	inc	sp
	push	de
	inc	sp
	ld	l,-8 (ix)
	ld	h,-7 (ix)
	push	hl
	call	_cpct_getScreenPtr
	pop	bc
;src/gui.c:133: cpct_drawSprite (sprite, vmem_actual, SP_HECHIZO_0_W, SP_HECHIZO_0_H);
	pop	de
	pop	iy
	push	iy
	push	de
	push	bc
	ld	de, #0x0704
	push	de
	push	hl
	push	iy
	call	_cpct_drawSprite
	pop	bc
;src/gui.c:134: i--;
	dec	b
	jr	00103$
00105$:
;src/gui.c:136: vmem_bufer = (u8*) 0xC000;
	ld	hl, #0xc000
	ex	(sp), hl
;src/gui.c:137: bufers--;
	dec	-9 (ix)
;src/gui.c:138: } while (bufers > 0);
	ld	a, -9 (ix)
	or	a, a
	jp	NZ, 00106$
	ld	sp, ix
	pop	ix
	ret
;src/gui.c:151: void pintarMuro(u8 x, u8 y, u8 filas, u8 columnas) {
;	---------------------------------
; Function pintarMuro
; ---------------------------------
_pintarMuro::
	call	___sdcc_enter_ix
	push	af
;src/gui.c:155: vmem_bufer = VMEM_BUFFER1;
	ld	bc, #0xc000
;src/gui.c:157: do {
	ld	-2 (ix), #0x02
;src/gui.c:158: for (filas2 = 0; filas2 < filas; filas2++) {
00117$:
	ld	d, #0x00
00110$:
	ld	a, d
	sub	a, 6 (ix)
	jr	NC,00102$
;src/gui.c:159: for (col2 = 0; col2 < columnas; col2++) {
	ld	l, d
	ld	e, l
	add	hl, hl
	add	hl, hl
	add	hl, de
	add	hl, hl
	add	hl, de
	ld	a, 5 (ix)
	add	a, l
	ld	e, a
	ld	-1 (ix), #0x00
00107$:
	ld	a, -1 (ix)
	sub	a, 7 (ix)
	jr	NC,00111$
;src/gui.c:160: cpct_drawSprite (sp_muro_ladrillos, cpct_getScreenPtr(vmem_bufer, x + (col2 * SP_MURO_LADRILLOS_W), y + (filas2 * SP_MURO_LADRILLOS_H)), SP_MURO_LADRILLOS_W, SP_MURO_LADRILLOS_H);
	ld	a, -1 (ix)
	add	a, a
	add	a, a
	ld	l, a
	ld	a, 4 (ix)
	add	a, l
	ld	h, a
	push	bc
	pop	iy
	push	bc
	push	de
	ld	a, e
	push	af
	inc	sp
	push	hl
	inc	sp
	push	iy
	call	_cpct_getScreenPtr
	pop	de
	pop	bc
	push	hl
	pop	iy
	push	bc
	push	de
	ld	hl, #0x0b04
	push	hl
	push	iy
	ld	hl, #_sp_muro_ladrillos
	push	hl
	call	_cpct_drawSprite
	pop	de
	pop	bc
;src/gui.c:159: for (col2 = 0; col2 < columnas; col2++) {
	inc	-1 (ix)
	jr	00107$
00111$:
;src/gui.c:158: for (filas2 = 0; filas2 < filas; filas2++) {
	inc	d
	jr	00110$
00102$:
;src/gui.c:163: vmem_bufer = VMEM_BUFFER2;
	ld	bc, #0x8000
;src/gui.c:164: } while (bufers-- > 0);
	ld	e, -2 (ix)
	dec	-2 (ix)
	ld	a, e
	or	a, a
	jr	NZ,00117$
	pop	af
	pop	ix
	ret
;src/gui.c:170: void pintarMarcadorSuperior() {
;	---------------------------------
; Function pintarMarcadorSuperior
; ---------------------------------
_pintarMarcadorSuperior::
	call	___sdcc_enter_ix
	push	af
	push	af
;src/gui.c:175: pintarMuro(0, 0, 4, 20);
	ld	hl, #0x1404
	push	hl
	ld	hl, #0x0000
	push	hl
	call	_pintarMuro
	pop	af
	pop	af
;src/gui.c:176: vmem_bufer = VMEM_BUFFER1;
	ld	bc, #0xc000
;src/gui.c:178: for (i = NUM_BUFFERS; i > 0; i--) {
	ld	-4 (ix), #0x02
00111$:
;src/gui.c:181: position = cpct_getScreenPtr(vmem_bufer, X_MARCADOR_PLAYER_1-1, Y_MARCADOR_SHOTS - 1);
	ld	-2 (ix), c
	ld	-1 (ix), b
	ld	hl, #0x050d
	push	hl
	ld	l,-2 (ix)
	ld	h,-1 (ix)
	push	hl
	call	_cpct_getScreenPtr
;src/gui.c:182: cpct_drawSolidBox (position, cpct_px2byteM0(6,6), 54, 27);
	push	hl
	ld	bc, #0x0606
	push	bc
	call	_cpct_px2byteM0
	ld	c, l
	pop	hl
	ld	b, #0x00
	ld	de, #0x1b36
	push	de
	push	bc
	push	hl
	call	_cpct_drawSolidBox
;src/gui.c:185: x = X_MARCADOR_PLAYER_1;
;src/gui.c:186: for (j = 0; j < 2; j++) {
	ld	bc,#0x0e00
00107$:
;src/gui.c:187: position  = cpct_getScreenPtr(vmem_bufer, x, Y_MARCADOR_SPELL);
	push	bc
	ld	a, #0x18
	push	af
	inc	sp
	push	bc
	inc	sp
	ld	l,-2 (ix)
	ld	h,-1 (ix)
	push	hl
	call	_cpct_getScreenPtr
	ld	de, #0x0714
	push	de
	ld	de, #0x0000
	push	de
	push	hl
	call	_cpct_drawSolidBox
	pop	bc
;src/gui.c:189: x = X_MARCADOR_PLAYER_2;
	ld	b, #0x2e
;src/gui.c:186: for (j = 0; j < 2; j++) {
	inc	c
	ld	a, c
	sub	a, #0x02
	jr	C,00107$
;src/gui.c:193: for (k = Y_MARCADOR_SHOTS; k <= Y_MARCADOR_SPELL; k = k + 9) {
	ld	-3 (ix), #0x06
00109$:
;src/gui.c:194: position = cpct_getScreenPtr(vmem_bufer, 35, k);
	ld	d, -3 (ix)
	ld	e,#0x23
	push	de
	ld	l,-2 (ix)
	ld	h,-1 (ix)
	push	hl
	call	_cpct_getScreenPtr
;src/gui.c:195: cpct_drawSolidBox (position, cpct_px2byteM0(1,1), 10, 7);
	push	hl
	ld	bc, #0x0101
	push	bc
	call	_cpct_px2byteM0
	ld	c, l
	pop	hl
	ld	b, #0x00
	ld	de, #0x070a
	push	de
	push	bc
	push	hl
	call	_cpct_drawSolidBox
;src/gui.c:193: for (k = Y_MARCADOR_SHOTS; k <= Y_MARCADOR_SPELL; k = k + 9) {
	ld	a, -3 (ix)
	add	a, #0x09
	ld	-3 (ix), a
	ld	a, #0x18
	sub	a, -3 (ix)
	jr	NC,00109$
;src/gui.c:199: if (bitOptions & mask_enable_countdown) {
	ld	hl,#_bitOptions+0
	bit	5, (hl)
	jr	Z,00104$
;src/gui.c:200: position = cpct_getScreenPtr(vmem_bufer, 34, Y_MARCADOR_TIME - 1);
	ld	hl, #0x2022
	push	hl
	ld	l,-2 (ix)
	ld	h,-1 (ix)
	push	hl
	call	_cpct_getScreenPtr
;src/gui.c:201: cpct_drawSolidBox (position, cpct_px2byteM0(6,6), 12, 8);
	push	hl
	ld	bc, #0x0606
	push	bc
	call	_cpct_px2byteM0
	ld	c, l
	pop	hl
	ld	b, #0x00
	ld	de, #0x080c
	push	de
	push	bc
	push	hl
	call	_cpct_drawSolidBox
;src/gui.c:203: position  = cpct_getScreenPtr(vmem_bufer, 35, Y_MARCADOR_TIME - 1);
	ld	hl, #0x2023
	push	hl
	ld	l,-2 (ix)
	ld	h,-1 (ix)
	push	hl
	call	_cpct_getScreenPtr
;src/gui.c:204: cpct_drawSolidBox (position, 0, 10, 7);
	ld	bc, #0x070a
	push	bc
	ld	bc, #0x0000
	push	bc
	push	hl
	call	_cpct_drawSolidBox
;src/gui.c:206: printTxt(":", 39, Y_MARCADOR_TIME, NO, 13);
	ld	hl, #0x0d00
	push	hl
	ld	hl, #0x2127
	push	hl
	ld	hl, #___str_0
	push	hl
	call	_printTxt
	pop	af
	pop	af
	pop	af
00104$:
;src/gui.c:209: vmem_bufer = VMEM_BUFFER2;
	ld	bc, #0x8000
;src/gui.c:178: for (i = NUM_BUFFERS; i > 0; i--) {
	dec	-4 (ix)
	ld	a, -4 (ix)
;src/gui.c:212: for (i = 0; i < NUM_JUGADORES; i++) {
	or	a,a
	jp	NZ,00111$
	ld	b,a
00113$:
;src/gui.c:213: pintarCaraJugador(i);
	push	bc
	push	bc
	inc	sp
	call	_pintarCaraJugador
	inc	sp
	pop	bc
;src/gui.c:214: pintarIconosMarcador(i, ICONO_VIDA);
	push	bc
	ld	a, #0x01
	push	af
	inc	sp
	push	bc
	inc	sp
	call	_pintarIconosMarcador
	pop	af
	pop	bc
;src/gui.c:215: pintarIconosMarcador(i, ICONO_HECHIZO);
	push	bc
	xor	a, a
	push	af
	inc	sp
	push	bc
	inc	sp
	call	_pintarIconosMarcador
	pop	af
	pop	bc
;src/gui.c:212: for (i = 0; i < NUM_JUGADORES; i++) {
	inc	b
	ld	a, b
	sub	a, #0x02
	jr	C,00113$
;src/gui.c:218: printTxt("SHOTS", CENTRADO, Y_MARCADOR_SHOTS + 1, SI, 0);
	ld	hl, #0x0001
	push	hl
	ld	hl, #0x0700
	push	hl
	ld	hl, #___str_1
	push	hl
	call	_printTxt
	pop	af
	pop	af
;src/gui.c:219: printTxt("LIVES", CENTRADO, Y_MARCADOR_LIFE + 1, SI, 0);
	ld	hl, #0x0001
	ex	(sp),hl
	ld	hl, #0x1000
	push	hl
	ld	hl, #___str_2
	push	hl
	call	_printTxt
	pop	af
	pop	af
;src/gui.c:220: printTxt("NAME", CENTRADO, Y_MARCADOR_SPELL + 1, SI, 0);
	ld	hl, #0x0001
	ex	(sp),hl
	ld	hl, #0x1900
	push	hl
	ld	hl, #___str_3
	push	hl
	call	_printTxt
	ld	sp,ix
	pop	ix
	ret
___str_0:
	.ascii ":"
	.db 0x00
___str_1:
	.ascii "SHOTS"
	.db 0x00
___str_2:
	.ascii "LIVES"
	.db 0x00
___str_3:
	.ascii "NAME"
	.db 0x00
;src/gui.c:224: void drawStats(u16 num, u8 stat, u8 player) {
;	---------------------------------
; Function drawStats
; ---------------------------------
_drawStats::
	call	___sdcc_enter_ix
	push	af
	push	af
	push	af
;src/gui.c:225: u8 x = 6 + (player * 61);
	ld	a, 7 (ix)
	ld	c, a
	add	a, a
	add	a, c
	add	a, a
	add	a, c
	add	a, a
	add	a, c
	add	a, a
	add	a, a
	add	a, c
	add	a, #0x06
	ld	c, a
;src/gui.c:227: u8 x2 = 0;
	ld	b, #0x00
;src/gui.c:230: switch (stat) {
	ld	a, 6 (ix)
	or	a, a
	jr	Z,00101$
	ld	a, 6 (ix)
	dec	a
	jr	Z,00102$
	ld	a, 6 (ix)
	sub	a, #0x02
	jr	Z,00103$
	jr	00104$
;src/gui.c:231: case 0:
00101$:
;src/gui.c:232: cpct_memcpy (txt, "WINS\0", 5);
	ld	hl, #0x0000
	add	hl, sp
	push	bc
	ld	de, #0x0005
	push	de
	ld	de, #___str_4
	push	de
	push	hl
	call	_cpct_memcpy
	pop	bc
;src/gui.c:233: break;
	jr	00104$
;src/gui.c:234: case 1:
00102$:
;src/gui.c:235: cpct_memcpy (txt, "SHOTS\0", 6);
	ld	hl, #0x0000
	add	hl, sp
	push	bc
	ld	de, #0x0006
	push	de
	ld	de, #___str_5
	push	de
	push	hl
	call	_cpct_memcpy
	pop	bc
;src/gui.c:236: x2 = 1;
	ld	b, #0x01
;src/gui.c:237: break;
	jr	00104$
;src/gui.c:238: case 2:
00103$:
;src/gui.c:239: cpct_memcpy (txt, "HITS\0", 5);
	ld	hl, #0x0000
	add	hl, sp
	push	bc
	ld	de, #0x0005
	push	de
	ld	de, #___str_6
	push	de
	push	hl
	call	_cpct_memcpy
	pop	bc
;src/gui.c:246: }
00104$:
;src/gui.c:248: y += stat * 23;
	ld	l, 6 (ix)
	ld	e, l
	add	hl, hl
	add	hl, hl
	add	hl, de
	add	hl, hl
	add	hl, de
	add	hl, hl
	add	hl, de
	ld	a, l
	add	a, #0x4f
	ld	d, a
;src/gui.c:249: printTxt(txt,  x - x2,  y, NO, 10);
	ld	a, c
	sub	a, b
	ld	b, a
	ld	iy,#0x0000
	add	iy,sp
	push	bc
	push	de
	ld	hl, #0x0a00
	push	hl
	ld	e, b
	push	de
	push	iy
	call	_printTxt
	pop	af
	pop	af
	pop	af
	pop	de
	pop	bc
;src/gui.c:250: printTxt("00", x + 1,   y + 9, NO, 13);
	ld	a, d
	add	a, #0x09
	ld	b, a
	ld	d, c
	inc	d
	push	bc
	push	de
	ld	hl, #0x0d00
	push	hl
	ld	c, d
	push	bc
	ld	hl, #___str_7
	push	hl
	call	_printTxt
	pop	af
	pop	af
	pop	af
	pop	de
	pop	bc
;src/gui.c:251: if (num > 99)      x += 1;
	ld	a, #0x63
	cp	a, 4 (ix)
	ld	a, #0x00
	sbc	a, 5 (ix)
	jr	C,00110$
;src/gui.c:252: else if (num > 9)  x += 3;
	ld	a, #0x09
	cp	a, 4 (ix)
	ld	a, #0x00
	sbc	a, 5 (ix)
	jr	NC,00106$
	ld	d, c
	inc	d
	inc	d
	inc	d
	jr	00110$
00106$:
;src/gui.c:253: else               x += 5;
	ld	a, c
	add	a, #0x05
	ld	d, a
00110$:
;src/gui.c:254: printInt(num,  x, y + 9, NO, 13);
	ld	hl, #0x0d00
	push	hl
	ld	c, d
	push	bc
	ld	l,4 (ix)
	ld	h,5 (ix)
	push	hl
	call	_printInt
	ld	sp,ix
	pop	ix
	ret
___str_4:
	.ascii "WINS"
	.db 0x00
	.db 0x00
___str_5:
	.ascii "SHOTS"
	.db 0x00
	.db 0x00
___str_6:
	.ascii "HITS"
	.db 0x00
	.db 0x00
___str_7:
	.ascii "00"
	.db 0x00
;src/gui.c:262: void gameOverScreen() {
;	---------------------------------
; Function gameOverScreen
; ---------------------------------
_gameOverScreen::
	call	___sdcc_enter_ix
	push	af
	push	af
	push	af
	dec	sp
;src/gui.c:267: playerWin = 0; // opcionMenu = 0;
	ld	-5 (ix), #0x00
;src/gui.c:270: cpct_akp_musicInit((u8*) m_gameover);
	ld	bc, #_m_gameover+0
	push	bc
	call	_cpct_akp_musicInit
	pop	af
;src/gui.c:271: reproducirMusica();
	call	_reproducirMusica
;src/gui.c:274: if (bitOptions & mask_enable_countdown) {
	ld	hl,#_bitOptions+0
	bit	5, (hl)
	jr	Z,00106$
;src/gui.c:275: while (jugador[0].vidas > 0 && jugador[1].vidas > 0) {
00102$:
	ld	iy, #_jugador + 26
	ld	c, 0 (iy)
	xor	a, a
	sub	a, c
	jp	PO, 00224$
	xor	a, #0x80
00224$:
	jp	P, 00106$
	ld	hl, #_jugador + 64
	ld	b, (hl)
	xor	a, a
	sub	a, b
	jp	PO, 00225$
	xor	a, #0x80
00225$:
	jp	P, 00106$
;src/gui.c:276: --jugador[0].vidas;
	dec	c
	ld	0 (iy), c
;src/gui.c:277: --jugador[1].vidas;
	ld	c, (hl)
	dec	c
	ld	(hl), c
	jr	00102$
00106$:
;src/gui.c:280: if (!jugador[0].vidas || !jugador[1].vidas) {
	ld	a,(#(_jugador + 0x001a) + 0)
	or	a, a
	jr	Z,00113$
	ld	a, (#(_jugador + 0x0040) + 0)
	or	a, a
	jp	NZ, 00114$
00113$:
;src/gui.c:281: pintarRecuadroDoble (19, y, 42, 34);
	ld	hl, #0x222a
	push	hl
	ld	hl, #0x4813
	push	hl
	call	_pintarRecuadroDoble
	pop	af
	pop	af
;src/gui.c:282: if (jugador[0].vidas != jugador[1].vidas) {
	ld	hl, #(_jugador + 0x001a) + 0
	ld	c, (hl)
	ld	a, (#(_jugador + 0x0040) + 0)
	sub	a, c
	jr	Z,00111$
;src/gui.c:283: printTxt("WINNING PLAYER", 24, y + 23, NO, 13);
	ld	hl, #0x0d00
	push	hl
	ld	hl, #0x5f18
	push	hl
	ld	hl, #___str_8
	push	hl
	call	_printTxt
	pop	af
	pop	af
	pop	af
;src/gui.c:284: if (jugador[0].vidas == 0) {
	ld	a, (#(_jugador + 0x001a) + 0)
	or	a, a
	jr	NZ,00108$
;src/gui.c:285: playerWin = 2;
	ld	-5 (ix), #0x02
	jr	00109$
00108$:
;src/gui.c:287: playerWin = 1;
	ld	-5 (ix), #0x01
00109$:
;src/gui.c:290: printInt(playerWin, 54, y + 23, NO, 13);
	ld	c, -5 (ix)
	ld	b, #0x00
	ld	hl, #0x0d00
	push	hl
	ld	hl, #0x5f36
	push	hl
	push	bc
	call	_printInt
	pop	af
	pop	af
	pop	af
;src/gui.c:291: jugador[playerWin - 1].wins++;
	ld	c, -5 (ix)
	dec	c
	ld	b,#0x00
	ld	l, c
	ld	h, b
	add	hl, hl
	add	hl, hl
	add	hl, hl
	add	hl, bc
	add	hl, hl
	add	hl, bc
	add	hl, hl
	ld	de, #_jugador
	add	hl, de
	ld	bc, #0x0021
	add	hl, bc
	ld	c, (hl)
	inc	c
	ld	(hl), c
	jr	00115$
00111$:
;src/gui.c:293: printTxt("TIE", CENTRADO, y + 23, NO, 13);
	ld	hl, #0x0d00
	push	hl
	ld	h, #0x5f
	push	hl
	ld	hl, #___str_9
	push	hl
	call	_printTxt
	pop	af
	pop	af
	pop	af
	jr	00115$
00114$:
;src/gui.c:296: pintarRecuadroDoble (19, y, 42, 19);
	ld	hl, #0x132a
	push	hl
	ld	hl, #0x4813
	push	hl
	call	_pintarRecuadroDoble
	pop	af
	pop	af
00115$:
;src/gui.c:299: printTxt("GAME OVER", CENTRADO, y + 7, NO, 10);
	ld	hl, #0x0a00
	push	hl
	ld	h, #0x4f
	push	hl
	ld	hl, #___str_10
	push	hl
	call	_printTxt
	pop	af
	pop	af
	pop	af
;src/gui.c:302: x = 3;
;src/gui.c:303: for (i = 0; i < NUM_JUGADORES; i++) {
	ld	de,#0x0300
00137$:
;src/gui.c:305: if (jugador[i].wins > 253)  jugador[i].wins  = 1; /// OMG!! QUIÉN LLEGARÁ A JUGAR 254 PARTIDAS??
	push	de
	ld	d,#0x00
	ld	l, e
	ld	h, d
	add	hl, hl
	add	hl, hl
	add	hl, hl
	add	hl, de
	add	hl, hl
	add	hl, de
	add	hl, hl
	pop	de
	ld	bc,#_jugador
	add	hl,bc
	ld	c, l
	ld	b, h
	ld	hl, #0x0021
	add	hl,bc
	ld	-2 (ix), l
	ld	-1 (ix), h
	ld	l, (hl)
	ld	a, #0xfd
	sub	a, l
	jr	NC,00118$
	ld	l,-2 (ix)
	ld	h,-1 (ix)
	ld	(hl), #0x01
00118$:
;src/gui.c:306: if (jugador[i].shots > 999) jugador[i].shots = 1; /// Y A 1000 SHOTS ??
	ld	hl, #0x0024
	add	hl,bc
	ld	-4 (ix), l
	ld	-3 (ix), h
	ld	a, (hl)
	inc	hl
	ld	h, (hl)
	ld	l, a
	ld	a, #0xe7
	cp	a, l
	ld	a, #0x03
	sbc	a, h
	jr	NC,00120$
	ld	l,-4 (ix)
	ld	h,-3 (ix)
	ld	(hl), #0x01
	inc	hl
	ld	(hl), #0x00
00120$:
;src/gui.c:307: if (jugador[i].hits > 999)  jugador[i].hits  = 1; /// Y YA 1000 HITS ....
	ld	hl, #0x0022
	add	hl,bc
	ld	c,l
	ld	b,h
	ld	a, (hl)
	inc	hl
	ld	h, (hl)
	ld	l, a
	ld	a, #0xe7
	cp	a, l
	ld	a, #0x03
	sbc	a, h
	jr	NC,00122$
	ld	l, c
	ld	h, b
	ld	(hl), #0x01
	inc	hl
	ld	(hl), #0x00
00122$:
;src/gui.c:309: pintarRecuadroDoble(x, y, 13, 74);
	push	bc
	push	de
	ld	hl, #0x4a0d
	push	hl
	ld	a, #0x48
	push	af
	inc	sp
	push	de
	inc	sp
	call	_pintarRecuadroDoble
	pop	af
	pop	af
	pop	de
	pop	bc
;src/gui.c:311: drawStats(jugador[i].wins, 0, i);
	ld	l,-2 (ix)
	ld	h,-1 (ix)
	ld	l, (hl)
	ld	h, #0x00
	push	bc
	push	de
	ld	a, e
	push	af
	inc	sp
	xor	a, a
	push	af
	inc	sp
	push	hl
	call	_drawStats
	pop	af
	pop	af
	pop	de
	pop	bc
;src/gui.c:312: drawStats(jugador[i].shots, 1, i);
	ld	l,-4 (ix)
	ld	h,-3 (ix)
	ld	d, (hl)
	inc	hl
	ld	h, (hl)
	push	bc
	push	de
	ld	b, e
	ld	c,#0x01
	push	bc
	ld	l, d
	push	hl
	call	_drawStats
	pop	af
	pop	af
	pop	de
;src/gui.c:313: drawStats(jugador[i].hits, 2, i);
	pop	hl
	ld	c, (hl)
	inc	hl
	ld	b, (hl)
	push	de
	ld	d, e
	ld	e,#0x02
	push	de
	push	bc
	call	_drawStats
	pop	af
	pop	af
	pop	de
;src/gui.c:315: x = 64;
	ld	d, #0x40
;src/gui.c:303: for (i = 0; i < NUM_JUGADORES; i++) {
	inc	e
	ld	a, e
	sub	a, #0x02
	jp	C, 00137$
;src/gui.c:319: pintarRecuadroDoble (19, y+50, 42, 44);
	ld	hl, #0x2c2a
	push	hl
	ld	hl, #0x7a13
	push	hl
	call	_pintarRecuadroDoble
	pop	af
	pop	af
;src/gui.c:320: printTxt("PRESS", CENTRADO, y+57, NO, 8);
	ld	hl, #0x0800
	push	hl
	ld	h, #0x81
	push	hl
	ld	hl, #___str_11
	push	hl
	call	_printTxt
	pop	af
	pop	af
	pop	af
;src/gui.c:321: printTxt("/R/ TO RESTART", CENTRADO, y+73, NO, 0);
	ld	hl, #0x0000
	push	hl
	ld	h, #0x91
	push	hl
	ld	hl, #___str_12
	push	hl
	call	_printTxt
	pop	af
	pop	af
	pop	af
;src/gui.c:322: printTxt("/M/ TO MENU", CENTRADO, y+81, NO, 0);
	ld	hl, #0x0000
	push	hl
	ld	h, #0x99
	push	hl
	ld	hl, #___str_13
	push	hl
	call	_printTxt
	pop	af
	pop	af
	pop	af
;src/gui.c:324: opcionMenu = 0;
	ld	hl,#_opcionMenu + 0
	ld	(hl), #0x00
;src/gui.c:325: color = 9;
	ld	-7 (ix), #0x09
;src/gui.c:326: timeWait = 0;
	ld	bc, #0x0000
;src/gui.c:327: vaciaBufferTeclado();
	push	bc
	call	_vaciaBufferTeclado
	pop	bc
;src/gui.c:329: do {
	ld	a, -5 (ix)
	sub	a, #0x02
	jr	NZ,00227$
	ld	a,#0x01
	jr	00228$
00227$:
	xor	a,a
00228$:
	ld	-4 (ix), a
00134$:
;src/gui.c:330: cpct_scanKeyboard();
	push	bc
	call	_cpct_scanKeyboard
	ld	hl, #0x4004
	call	_cpct_isKeyPressed
	pop	bc
	ld	a, l
	or	a, a
	jr	Z,00125$
;src/gui.c:333: opcionMenu = VOLVER_AL_MENU;
	ld	hl,#_opcionMenu + 0
	ld	(hl), #0x01
00125$:
;src/gui.c:335: if (cpct_isKeyPressed(Key_R)) {
	push	bc
	ld	hl, #0x0406
	call	_cpct_isKeyPressed
	pop	bc
	ld	a, l
	or	a, a
	jr	Z,00127$
;src/gui.c:336: opcionMenu = SEGUIR_JUGANDO;
	ld	hl,#_opcionMenu + 0
	ld	(hl), #0x02
;src/gui.c:337: backToMenu = NO;
	ld	hl,#_backToMenu + 0
	ld	(hl), #0x00
;src/gui.c:338: vaciaBufferTeclado();
	push	bc
	call	_vaciaBufferTeclado
	pop	bc
00127$:
;src/gui.c:342: if (playerWin != 0) {
	ld	a, -5 (ix)
	or	a, a
	jp	Z, 00135$
;src/gui.c:343: if (++timeWait > 1200) {
	inc	bc
	ld	a, #0xb0
	cp	a, c
	ld	a, #0x04
	sbc	a, b
	jp	NC, 00135$
;src/gui.c:345: color = (color == 9 ? 14 : 9);
	ld	a, -7 (ix)
	sub	a, #0x09
	jr	NZ,00141$
	ld	c, #0x0e
	jr	00142$
00141$:
	ld	c, #0x09
00142$:
;src/gui.c:346: byteColor = cpct_px2byteM0(color, color);
	ld	-7 (ix), c
	ld	a, c
	push	af
	inc	sp
	ld	a, -7 (ix)
	push	af
	inc	sp
	call	_cpct_px2byteM0
	ld	c, l
;src/gui.c:347: x = 3;
	ld	-6 (ix), #0x03
;src/gui.c:348: if (playerWin == 2) x = 64;
	ld	a, -4 (ix)
	or	a, a
	jr	Z,00129$
	ld	-6 (ix), #0x40
00129$:
;src/gui.c:349: vmem_pos = cpct_getScreenPtr (vmem_start, x, 72);
	ld	de, (_vmem_start)
	push	bc
	ld	a, #0x48
	push	af
	inc	sp
	ld	a, -6 (ix)
	push	af
	inc	sp
	push	de
	call	_cpct_getScreenPtr
	pop	bc
;src/gui.c:350: cpct_drawSolidBox (vmem_pos, byteColor, 13, 2);
	ld	b, #0x00
	push	hl
	push	bc
	ld	de, #0x020d
	push	de
	push	bc
	push	hl
	call	_cpct_drawSolidBox
	pop	bc
	pop	hl
;src/gui.c:351: cpct_drawSolidBox (vmem_pos, byteColor, 1, y + 2);
	push	bc
	ld	de, #0x4a01
	push	de
	push	bc
	push	hl
	call	_cpct_drawSolidBox
	pop	bc
;src/gui.c:352: cpct_drawSolidBox (cpct_getScreenPtr (vmem_start, x, 72 + y), byteColor, 13, 2);
	ld	de, (_vmem_start)
	push	bc
	ld	a, #0x90
	push	af
	inc	sp
	ld	a, -6 (ix)
	push	af
	inc	sp
	push	de
	call	_cpct_getScreenPtr
	pop	bc
	push	bc
	ld	de, #0x020d
	push	de
	push	bc
	push	hl
	call	_cpct_drawSolidBox
	pop	bc
;src/gui.c:353: cpct_drawSolidBox (cpct_getScreenPtr (vmem_start, x + 12, 72), byteColor, 1, y + 2);
	ld	a, -6 (ix)
	add	a, #0x0c
	ld	e, a
	ld	hl, (_vmem_start)
	push	bc
	ld	d,#0x48
	push	de
	push	hl
	call	_cpct_getScreenPtr
	pop	bc
	ld	de, #0x4a01
	push	de
	push	bc
	push	hl
	call	_cpct_drawSolidBox
;src/gui.c:354: timeWait = 0;
	ld	bc, #0x0000
00135$:
;src/gui.c:358: } while(!opcionMenu);
	ld	a,(#_opcionMenu + 0)
	or	a, a
	jp	Z, 00134$
;src/gui.c:359: sonidoTecla();       
	call	_sonidoTecla
	ld	sp, ix
	pop	ix
	ret
___str_8:
	.ascii "WINNING PLAYER"
	.db 0x00
___str_9:
	.ascii "TIE"
	.db 0x00
___str_10:
	.ascii "GAME OVER"
	.db 0x00
___str_11:
	.ascii "PRESS"
	.db 0x00
___str_12:
	.ascii "/R/ TO RESTART"
	.db 0x00
___str_13:
	.ascii "/M/ TO MENU"
	.db 0x00
	.area _CODE
	.area _INITIALIZER
	.area _CABS (ABS)
