;--------------------------------------------------------
; File Created by SDCC : free open source ANSI-C Compiler
; Version 3.6.8 #9946 (CYGWIN)
;--------------------------------------------------------
	.module main
	.optsdcc -mz80
	
;--------------------------------------------------------
; Public variables in this module
;--------------------------------------------------------
	.globl _main
	.globl _initComputer
	.globl _setDefaultKeys
	.globl _gameCountdown
	.globl _game
	.globl _initSprites
	.globl _menu
	.globl _cpct_akp_SFXPlay
	.globl _cpct_akp_SFXInit
	.globl _cpct_akp_musicPlay
	.globl _cpct_akp_musicInit
	.globl _cpct_setVideoMemoryPage
	.globl _cpct_setPALColour
	.globl _cpct_setPalette
	.globl _cpct_waitVSYNC
	.globl _cpct_setVideoMode
	.globl _cpct_setStackLocation
	.globl _cpct_memset
	.globl _cpct_setInterruptHandler
	.globl _cpct_disableFirmware
	.globl _countdownInterrupt
	.globl _objetos_ptr
	.globl _item
	.globl _hechizo
	.globl _jugador
	.globl _key
	.globl _countdownMin
	.globl _countdownSec
	.globl _anterior_id_item
	.globl _bitOptions
	.globl _opcionMenu
	.globl _velocidad_musica
	.globl _contador_musica
	.globl _bucle
	.globl _backToMenu
	.globl _mapa_ptr
	.globl _vmem_swap
	.globl _vmem_page
	.globl _vmem_start
	.globl _mapa
	.globl _mapa_id_cambio
	.globl _mapa_halt_switch
	.globl _selectedStage
	.globl _mapa_actual
	.globl _ciclo
	.globl _nomPersonajes
	.globl _sprites_player1
	.globl _sprites_player0
	.globl _setInterruptAtVSYNCStart
	.globl _intHandler
	.globl _borraPantallas
	.globl _seleccionarMonoBufer
	.globl _playMusic
	.globl _playSFX
	.globl _reproducirMusica
;--------------------------------------------------------
; special function registers
;--------------------------------------------------------
;--------------------------------------------------------
; ram data
;--------------------------------------------------------
	.area _DATA
_ciclo::
	.ds 1
_mapa_actual::
	.ds 1
_selectedStage::
	.ds 1
_mapa_halt_switch::
	.ds 2
_mapa_id_cambio::
	.ds 1
_mapa::
	.ds 360
_vmem_start::
	.ds 2
_vmem_page::
	.ds 1
_vmem_swap::
	.ds 1
_mapa_ptr::
	.ds 2
_backToMenu::
	.ds 1
_bucle::
	.ds 1
_contador_musica::
	.ds 1
_velocidad_musica::
	.ds 1
_opcionMenu::
	.ds 1
_bitOptions::
	.ds 1
_anterior_id_item::
	.ds 1
_countdownSec::
	.ds 1
_countdownMin::
	.ds 1
_key::
	.ds 20
_jugador::
	.ds 76
_hechizo::
	.ds 34
_item::
	.ds 35
_objetos_ptr::
	.ds 2
;--------------------------------------------------------
; ram data
;--------------------------------------------------------
	.area _INITIALIZED
_countdownInterrupt::
	.ds 1
;--------------------------------------------------------
; absolute external ram data
;--------------------------------------------------------
	.area _DABS (ABS)
;--------------------------------------------------------
; global & static initialisations
;--------------------------------------------------------
	.area _HOME
	.area _GSINIT
	.area _GSFINAL
	.area _GSINIT
;--------------------------------------------------------
; Home
;--------------------------------------------------------
	.area _HOME
	.area _HOME
;--------------------------------------------------------
; code
;--------------------------------------------------------
	.area _CODE
;src/main.c:66: void setDefaultKeys() {
;	---------------------------------
; Function setDefaultKeys
; ---------------------------------
_setDefaultKeys::
;src/main.c:67: key[0].up    = Key_1;
	ld	hl, #0x0108
	ld	(_key), hl
;src/main.c:68: key[0].down  = Key_Q;
	ld	h, #0x08
	ld	((_key + 0x0002)), hl
;src/main.c:69: key[0].left  = Key_D;
	ld	hl, #0x2007
	ld	((_key + 0x0004)), hl
;src/main.c:70: key[0].right = Key_F;
	ld	l, #0x06
	ld	((_key + 0x0006)), hl
;src/main.c:71: key[0].fire  = Key_Z;
	ld	hl, #0x8008
	ld	((_key + 0x0008)), hl
;src/main.c:73: key[1].up    = Key_F7;
	ld	hl, #0x0401
	ld	((_key + 0x000a)), hl
;src/main.c:74: key[1].down  = Key_F4;
	ld	hl, #0x1002
	ld	((_key + 0x000c)), hl
;src/main.c:75: key[1].left  = Key_F2;
	ld	hl, #0x4001
	ld	((_key + 0x000e)), hl
;src/main.c:76: key[1].right = Key_F3;
	ld	hl, #0x2000
	ld	((_key + 0x0010)), hl
;src/main.c:77: key[1].fire  = Key_F0;
	ld	hl, #0x8001
	ld	((_key + 0x0012)), hl
	ret
_sprites_player0:
	.ds 384
_sprites_player1:
	.ds 384
_nomPersonajes:
	.ascii "ED SPELLS "
	.db 0x00
	.ascii " MAGIK MAX"
	.db 0x00
	.ascii " LARCENAS "
	.db 0x00
	.ascii "  FROGGY  "
	.db 0x00
	.ascii "  ZOMBIE  "
	.db 0x00
	.ascii " WITCHER  "
	.db 0x00
;src/main.c:83: cpctm_createTransparentMaskTable(sp_tablaTrans, 0x200, M0, 0);
;	---------------------------------
; Function dummy_cpct_transparentMaskTable0M0_container
; ---------------------------------
_dummy_cpct_transparentMaskTable0M0_container::
	.area _sp_tablaTrans_ (ABS) 
	.org 0x200 
	 _sp_tablaTrans::
	.db 0xFF, 0xAA, 0x55, 0x00, 0xAA, 0xAA, 0x00, 0x00 
	.db 0x55, 0x00, 0x55, 0x00, 0x00, 0x00, 0x00, 0x00 
	.db 0xAA, 0xAA, 0x00, 0x00, 0xAA, 0xAA, 0x00, 0x00 
	.db 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00 
	.db 0x55, 0x00, 0x55, 0x00, 0x00, 0x00, 0x00, 0x00 
	.db 0x55, 0x00, 0x55, 0x00, 0x00, 0x00, 0x00, 0x00 
	.db 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00 
	.db 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00 
	.db 0xAA, 0xAA, 0x00, 0x00, 0xAA, 0xAA, 0x00, 0x00 
	.db 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00 
	.db 0xAA, 0xAA, 0x00, 0x00, 0xAA, 0xAA, 0x00, 0x00 
	.db 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00 
	.db 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00 
	.db 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00 
	.db 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00 
	.db 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00 
	.db 0x55, 0x00, 0x55, 0x00, 0x00, 0x00, 0x00, 0x00 
	.db 0x55, 0x00, 0x55, 0x00, 0x00, 0x00, 0x00, 0x00 
	.db 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00 
	.db 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00 
	.db 0x55, 0x00, 0x55, 0x00, 0x00, 0x00, 0x00, 0x00 
	.db 0x55, 0x00, 0x55, 0x00, 0x00, 0x00, 0x00, 0x00 
	.db 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00 
	.db 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00 
	.db 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00 
	.db 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00 
	.db 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00 
	.db 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00 
	.db 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00 
	.db 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00 
	.db 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00 
	.db 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00 
	.area _CSEG (REL, CON) 
;src/main.c:88: void setInterruptAtVSYNCStart(void *intHdl) {
;	---------------------------------
; Function setInterruptAtVSYNCStart
; ---------------------------------
_setInterruptAtVSYNCStart::
;src/main.c:89: cpct_waitVSYNC();
	call	_cpct_waitVSYNC
;src/main.c:93: __endasm;
	halt
	halt
;src/main.c:94: cpct_waitVSYNC();
	call	_cpct_waitVSYNC
;src/main.c:95: cpct_setInterruptHandler(intHdl);
	pop	bc
	pop	hl
	push	hl
	push	bc
	jp  _cpct_setInterruptHandler
;src/main.c:101: void intHandler() {
;	---------------------------------
; Function intHandler
; ---------------------------------
_intHandler::
;src/main.c:102: if(--contador_musica == 0){
	ld	iy, #_contador_musica
	dec	0 (iy)
	ld	a, 0 (iy)
	or	a, a
	jr	NZ,00102$
;src/main.c:103: contador_musica = velocidad_musica + 1;
	ld	hl, #_contador_musica
	ld	a,(#_velocidad_musica + 0)
	inc	a
	ld	(hl), a
;src/main.c:104: playMusic();
	call	_playMusic
00102$:
;src/main.c:106: if (--countdownInterrupt == 0) {
	ld	iy, #_countdownInterrupt
	dec	0 (iy)
	ld	a, 0 (iy)
	or	a, a
	jr	NZ,00104$
;src/main.c:107: countdownInterrupt = 254; // 5 interrupciones por segundo aprox
	ld	0 (iy), #0xfe
;src/main.c:108: gameCountdown();
	call	_gameCountdown
00104$:
;src/main.c:111: bucle++;
	ld	hl, #_bucle+0
	inc	(hl)
	ret
;src/main.c:114: void initComputer() {
;	---------------------------------
; Function initComputer
; ---------------------------------
_initComputer::
;src/main.c:115: cpct_disableFirmware();
	call	_cpct_disableFirmware
;src/main.c:116: setInterruptAtVSYNCStart(intHandler);
	ld	bc, #_intHandler
	push	bc
	call	_setInterruptAtVSYNCStart
;src/main.c:117: cpct_setBorder(HW_BLACK);
	ld	hl, #0x1410
	ex	(sp),hl
	call	_cpct_setPALColour
;src/main.c:118: cpct_setPalette(paleta, 16);
	ld	hl, #0x0010
	push	hl
	ld	hl, #_paleta
	push	hl
	call	_cpct_setPalette
;src/main.c:119: cpct_setVideoMode(0);
	ld	l, #0x00
	call	_cpct_setVideoMode
	ret
;src/main.c:126: void main(void) {
;	---------------------------------
; Function main
; ---------------------------------
_main::
;src/main.c:127: cpct_setStackLocation ((u8*) 0x7FFF);
	ld	hl, #0x7fff
	call	_cpct_setStackLocation
;src/main.c:128: initComputer();
	call	_initComputer
;src/main.c:130: bitOptions = mask_sfx_on | mask_music_on;
	ld	hl,#_bitOptions + 0
	ld	(hl), #0x03
;src/main.c:131: selectedStage = 1;
	ld	hl,#_selectedStage + 0
	ld	(hl), #0x01
;src/main.c:133: setDefaultKeys();
	call	_setDefaultKeys
;src/main.c:134: initSprites();
	call	_initSprites
;src/main.c:136: while(1) {
00105$:
;src/main.c:137: menu();
	call	_menu
;src/main.c:138: backToMenu = 0;
	ld	hl,#_backToMenu + 0
	ld	(hl), #0x00
;src/main.c:139: while (opcionMenu == SEGUIR_JUGANDO) {
00101$:
	ld	a,(#_opcionMenu + 0)
	sub	a, #0x02
	jr	NZ,00105$
;src/main.c:140: game();
	call	_game
	jr	00101$
;src/main.c:148: void borraPantallas() {
;	---------------------------------
; Function borraPantallas
; ---------------------------------
_borraPantallas::
;src/main.c:149: cpct_memset(VMEM_BUFFER1, 0, 0x4000);
	ld	hl, #0x4000
	push	hl
	xor	a, a
	push	af
	inc	sp
	ld	h, #0xc0
	push	hl
	call	_cpct_memset
;src/main.c:150: cpct_memset(VMEM_BUFFER2, 0, 0x4000);
	ld	hl, #0x4000
	push	hl
	xor	a, a
	push	af
	inc	sp
	ld	h, #0x80
	push	hl
	call	_cpct_memset
	ret
;src/main.c:156: void seleccionarMonoBufer() {
;	---------------------------------
; Function seleccionarMonoBufer
; ---------------------------------
_seleccionarMonoBufer::
;src/main.c:157: vmem_swap   = 0;
	ld	hl,#_vmem_swap + 0
	ld	(hl), #0x00
;src/main.c:158: vmem_start  = VMEM_BUFFER1;
	ld	hl, #0xc000
	ld	(_vmem_start), hl
;src/main.c:159: vmem_page   = cpct_pageC0;
	ld	hl,#_vmem_page + 0
	ld	(hl), #0x30
;src/main.c:160: cpct_setVideoMemoryPage(vmem_page);
	ld	l, #0x30
	jp  _cpct_setVideoMemoryPage
;src/main.c:166: void playMusic() {
;	---------------------------------
; Function playMusic
; ---------------------------------
_playMusic::
;src/main.c:174: __endasm;
	.db	0x08
	EXX
	PUSH	AF
	PUSH	BC
	PUSH	DE
	PUSH	HL
;src/main.c:175: cpct_akp_musicPlay();
	call	_cpct_akp_musicPlay
;src/main.c:183: __endasm;
	POP	HL
	POP	DE
	POP	BC
	POP	AF
	EXX
	.db	0x08
	ret
;src/main.c:194: void playSFX(u8 instrumento, u8 nota) {
;	---------------------------------
; Function playSFX
; ---------------------------------
_playSFX::
;src/main.c:195: if (bitOptions & mask_sfx_on) {
	ld	hl,#_bitOptions+0
	bit	1, (hl)
	ret	Z
;src/main.c:196: cpct_akp_SFXInit (m_sfx);
	ld	hl, #_m_sfx
	push	hl
	call	_cpct_akp_SFXInit
;src/main.c:197: cpct_akp_SFXPlay (instrumento, 14, nota, 0, 0, AY_CHANNEL_B);
	ld	h,#0x02
	ex	(sp),hl
	inc	sp
	ld	hl, #0x0000
	push	hl
	xor	a, a
	push	af
	inc	sp
	ld	hl, #7+0
	add	hl, sp
	ld	d, (hl)
	ld	e,#0x0e
	push	de
	ld	hl, #8+0
	add	hl, sp
	ld	a, (hl)
	push	af
	inc	sp
	call	_cpct_akp_SFXPlay
	pop	af
	pop	af
	pop	af
	inc	sp
	ret
;src/main.c:208: void reproducirMusica() {
;	---------------------------------
; Function reproducirMusica
; ---------------------------------
_reproducirMusica::
;src/main.c:209: if (!(bitOptions & mask_music_on)) {
	ld	hl,#_bitOptions+0
	bit	0, (hl)
	jp	NZ,_cpct_akp_musicPlay
;src/main.c:210: cpct_akp_musicInit((u8*) m_sfx);
	ld	bc, #_m_sfx+0
	push	bc
	call	_cpct_akp_musicInit
	pop	af
;src/main.c:212: cpct_akp_musicPlay();
	jp  _cpct_akp_musicPlay
	.area _CODE
	.area _INITIALIZER
__xinit__countdownInterrupt:
	.db #0x01	; 1
	.area _CABS (ABS)
